//=====================================================\\
//***********~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2007-8       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***********~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*************\\
//=====================================================\\

//=================test bench -->vhdl==================\\

//function testdata=readfromhdlfiletoablock()

 vhdlcontent='';  //get the content of the hdl file by lines
 hdlFilePath='';
 
 itspath='';      //hdl file path
 itsfname='';     //hdl file name
 itsextension=''; //hdl file extension
 
 hdlFilePath=tk_getfile("*.vhd","SCI/macros/scicos-hdl/vhdl/IPCore"); //,title="Select your vhdl file",
 
 vhdlcontent=mgetl(hdlFilePath); //read lines from an ascii file
 
 [itspath,itsfname,itsextension]=fileparts(hdlFilePath);// get file's parameters
  
 mclose(hdlFilePath); //close the file
 
 
 tmp_en1 = grep(vhdlcontent,'(');
 tmp_en2 = grep(vhdlcontent,');');
 
 if(tmp_en1(1)==0) | (tmp_en2(1)==0)
   
   message("This is Error File!!!");
   
   resume;
   
 end
 
 EN_HDL=[];
 
 EN_HDL_Count =1;
 
 IN_Counter =0;
 OUT_Counter =0;
 
 for i=tmp_en1(1):tmp_en2(1)

     EN_HDL(EN_HDL_Count )= vhdlcontent(i);
  

     
     if( strindex(EN_HDL(EN_HDL_Count ),ascii(32)+'in'+ascii(32))> 0)
        IN_Counter =IN_Counter +1;
     end
     
     if( strindex(EN_HDL(EN_HDL_Count ),ascii(32)+'out'+ascii(32))> 0)
        OUT_Counter =OUT_Counter +1;
     end
     
     EN_HDL_Count = EN_HDL_Count + 1;
     
 end

 itsfname_part = length(itsfname)-3;
 
 itsname_part_str = strsplit(itsfname,itsfname_part);
 
 message(itsname_part_str)

testdata(1) = "function [x,y,typ]="+itsfname+"(job,arg1,arg2)";
testdata(2) = "// Copyright ScicosHDL0.41";
testdata(3) = "x=[];y=[];typ=[];";
testdata(4) = "select job";
testdata(5) = "case "+ascii(39)+"plot"+ascii(39)+" then";
testdata(6) = "  sgn=arg1.model.ipar";
testdata(7) = "  standard_draw(arg1)";
testdata(8) = "case "+ascii(39)+"getinputs"+ascii(39)+" then";
testdata(9) = "  [x,y,typ]=standard_inputs(arg1)";
testdata(10) = "case "+ascii(39)+"getoutputs"+ascii(39)+" then";
testdata(11) = "  [x,y,typ]=standard_outputs(arg1)";
testdata(12) = "case "+ascii(39)+"getorigin"+ascii(39)+" then";
testdata(13) = "  [x,y]=standard_origin(arg1)";
testdata(14) = "case "+ascii(39)+"set"+ascii(39)+" then";
testdata(15) = "    x=arg1;";
testdata(16) = "case "+ascii(39)+"define"+ascii(39)+" then";

testdata(17) = "  model=scicos_model()";
testdata(18) = "  model.sim=list("+ascii(39)+"kcCom"+ascii(39)+",3)";//?????????????????????????//
testdata(19) = "  model.in=-ones("+string(IN_Counter)+",1)";
testdata(20) = "model.out=-ones("+string(OUT_Counter)+",1)";

RPAR_VAL = length(truthtable_IDC)+1;

testdata(21) = " model.rpar="+string(RPAR_VAL);//
testdata(22) = "model.blocktype="+ascii(39)+"c"+ascii(39)+"";
testdata(23) = "model.dep_ut=[%t %f]";

testdata(24) = "exprs="+ascii(34)+"AAA"+ascii(34);

testdata(25) = "gr_i=["+ascii(39)+"xstringb(orig(1),orig(2),"+ascii(39)+""+ascii(39)+itsname_part_str(1)+ascii(39)+""+ascii(39)+",sz(1),sz(2),"+ascii(39)+""+ascii(39)+"fill"+ascii(39)+""+ascii(39)+")"+ascii(39)+"]";

IOsize=0
IOsize=(IN_Counter+OUT_Counter)/5;

IOsize=int(IOsize+1.5)


testdata(26) = "x=standard_define([2 "+string(IOsize)+"],model, exprs,gr_i)";
testdata(27) = "end";
testdata(28) = "endfunction";
 

 
 strAdd ="";// "truthtable_IDC(69)=list(2,["+ascii(39)+itsfname+ascii(39)+","+ascii(39)+ itsname_part_str+ascii(39)+"],"+string(IN_Counter)+","+string(OUT_Counter)+",2,"+ascii(39)+ itsname_part_str+ascii(39)+")"
 
 mputl(testdata,"SCI/macros/scicos_blocks/HDL_FromHDLfile_UI/"+itsfname+'.sci');
 
  //endfunction
message("Please Add to  global_define.sci -> " +strAdd);



