function  block = hdlzk_testbench_sim(block, flag)
//zd&kc scicos-hdl 0.5 2007
//**
// Computational function for D type Flip Flop 
//**
   //block.opar -> test array model.opar =list("101","100","001")
   //message("start")
   outputNum=block.nout; // number of output ports
   refence_N=0;
  //message("output="+string(outputNum)+'----'+string(block.nout))
   //** Simulation state 
   Derivative = 0 ;
   OutUpdate  = 1 ;
   StateUpdate = 2 ;
   DelayTime = 3 ;
   Initialization = 4 ;
   Ending = 5;
   ReInit = 6;
   ImplicitB = 7;
   Mode = 9;
   
    for i=1:outputNum 
        if length(block.opar(i))>refence_N then
           refence_N=length(block.opar(i));
        end    
    end 

    for i=1:outputNum 
         if length(block.opar(i))<refence_N  then  // if opar(i)0,10,0001 ->0000,1000,0001
            Num_temp=refence_N-length(block.opar(i))  
            for n=Num_temp:refence_N
                block.opar(i)= block.opar(i)+'0';
            end    
         end
    end 
  
    data_temp='';
    opar_newd=list();                                    //opar_newd (1)(2)(3)(4) 
    for n=1:refence_N                                    //out1       0  1  0  1
        for kc=1:outputNum                                //out2       1  0  1  1
              data_temp=data_temp+part(block.opar(kc),n); //out3       0  0  1  0
        end 
        opar_newd(n)=data_temp;                           
        data_temp='';                                         
    end                
   
   

      

   if (flag==Initialization)|(flag==ReInit) |(flag==Ending) then
      //message("+ flag= "+string(flag)+"refence_N="+string(refence_N)+"block.z(1)="+string(block.z(1)))
      for i=1:outputNum 
         block.outptr(i)(1)=0;  //  initial the output data
//         if length(block.opar(i))>refence_N then
//            refence_N=length(block.opar(i));
//         end    
      end 
    
      block.z(1)=1;                 // 1,2,3..., control out put array
      return;
  end

   if flag==StateUpdate then
    
      block.z(1)=block.z(1)+1;
      if block.z(1)==refence_N+1 then 
         block.z(1)=block.z(1)-1
      end    
    // message("= flag="+string(flag)+" block.z(1)"+string(block.z(1)))
      return;
   end

   if  flag==OutUpdate then // start the output update  
 //message("*** flag="+string(flag)+" block.z(1)"+string(block.z(1)))
//       for i=1:outputNum 
//         if length(block.opar(i))>refence_N then
//            refence_N=length(block.opar(i));
//         end    
//       end 
//
//       for i=1:outputNum 
//      
//         if length(block.opar(i))<refence_N  then  // if opar(i)0,10,0001 ->0000,1000,0001
//            Num_temp=refence_N-length(block.opar(i))  
//            for n=Num_temp:refence_N
//                block.opar(i)= block.opar(i)+'0';
//            end    
//         end
//       end 
//  
//       data_temp='';
//       opar_newd=list();                                  //opar_newd (1)(2)(3)(4) 
//       for n=1:refence_N                                  //out1       0  1  0  1
//          for kc=1:outputNum                              //out2       1  0  1  1
//              data_temp=data_temp+part(block.opar(kc),n); //out3       0  0  1  0
//          end 
//          opar_newd(n)=data_temp;                           //z z z
//          data_temp='';                                         //1 2 3
//       end                                                    //1 0 1 ----         
// message("new"+opar_newd(block.z(1)))                                                       //0 1 1 ----  out put data
       for j=1:outputNum                             //0 0 0
           if (part(opar_newd(block.z(1)),j)=='0') then                 
               block.outptr(j)(1)=0;  
           else
              block.outptr(j)(1)=1;
           end   
       end  
     //message("end")
   end //end of the output data
 
endfunction
