function [x,y,typ] = hdl_ip_interf(job,arg1,arg2)
//zd&kc scicos-hdl 0.5 2008
x=[];y=[];typ=[];

select job
  
  case 'plot' then
      block_name=arg1.model.opar(2);
      standard_draw(arg1)
       //message('*')
  case 'getinputs' then
      [x,y,typ]=standard_inputs(arg1)     
       //message('**')
  case 'getoutputs' then
      [x,y,typ]=standard_outputs(arg1) 
       //message('***')
  case 'getorigin' then
      [x,y]=standard_origin(arg1)    
       //message('****')
  case 'set' then
    
      global kczd_scicos_hdl_set ;      // control the dialog  
      if  kczd_scicos_hdl_set ==0 then
          x = arg1;
          return;
      end
         
      x = arg1;
      graphics  = arg1.graphics ;
      exprs1    = graphics.exprs;
      model     = arg1.model;

      while %t do
           //parameters=list((2),"Ԫ",˿Ŀ,˿Ŀ,[˿],[˿]);  
           //exprs1=2,"vhdl_file_name","block_name",2,2,["in1";"in2"],["out1";"out2"]

           [ok,exprs1] = getvalue('Set Parameters ','Parameters:', list('str',-1), exprs1) ;         
           
           if ~ok then
              break ;     //** exit point 
           end

           Parameters_BLOCK = list();
  
           execstr("Parameters_BLOCK=list("+exprs1+")");

           nin=-ones(Parameters_BLOCK(4),1);             
           out=-ones(Parameters_BLOCK(5),1);                               
                      
           // verify that the block parameters are OK 
           [model, graphics, ok] = check_io(model, graphics, nin, out, [], []);
           
           if ~ok then
              break;
           end

           //xx1////////////////////////////////////////////////////////

           if ok then 

               //model.opar     = Parameters_BLOCK ; //number of inputs 
               model.opar(1)  = Parameters_BLOCK(1) ; //number of inputs 
               model.opar(2)  = Parameters_BLOCK(2) ; //number of inputs 
               model.opar(3)  = Parameters_BLOCK(3) ; //number of inputs 
               model.opar(4)  = Parameters_BLOCK(4) ; //number of inputs                
               model.opar(5)  = Parameters_BLOCK(5) ; //number of inputs 
               model.opar(6)  = Parameters_BLOCK(6) ; //number of inputs 
               model.opar(7)  = Parameters_BLOCK(7) ; //number of inputs                
              //some code for users
              //exprs1=2,"vhdl_file_name","block_name",2,2,["in1";"in2"],["out1";"out2"]
              
              //library IEEE;
              //use ieee.std_logic_1164.ALL;
              //entity andgate_2_1 is
              //port(
              //in_1: in std_logic;
              //in_2: in std_logic;
              //out_1: out std_logic);
              //end andgate_2_1;
              //architecture NXU_beh of andgate_2_1 is
              // --******************************************************
              //  --VHDL compiler
              // 
              //  --Powered by scicos-hdl ZhangDong&KangCai 2008
              // 
              //  --http://scicoshdl.sourceforge.net
              //
              // --*********************************************************************************
              
              // 1. vhdl codes head 
              //** debug message('+')
              //** debug pause
              vhdl_headData=[];
              vhdl_headData(1)="library IEEE;" ;
              vhdl_headData(2)="use ieee.std_logic_1164.ALL;" ;
              vhdl_headData(3)="entity" + ascii(32) +  model.opar(2) + ascii(32) +  "is" ;
              vhdl_headData(4)="port(" ;
              
              for i=1:  model.opar(4) // in put define
                  vhdl_headData(4+i)=ascii(32)+ascii(32)+model.opar(6)(i)+":"+ascii(32)+"in"+ ascii(32)+"std_logic;" ;                
              end  
            
              for i=1:  model.opar(5)-1 // out put define
                  vhdl_headData(size(vhdl_headData,1)+i)=ascii(32)+ascii(32)+model.opar(7)(i)+":"+ascii(32)+"out"+ ascii(32)+"std_logic;" ;                
              end  
              
              vhdl_headData(size(vhdl_headData,1)+1)=ascii(32)+ascii(32)+model.opar(7)(model.opar(5))+":"+ascii(32)+"out"+ ascii(32)+"std_logic);" ;  
              
              vhdl_headData(size(vhdl_headData,1)+1)="end"+ascii(32)+model.opar(2)+";" ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= "architecture behavior of "+model.opar(2) + ascii(32)+ "is"
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;  
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= " ";
              
              vhdl_headData(size(vhdl_headData,1)+1)= "add code here ...... ";
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;  
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= " ";
              
              vhdl_headData(size(vhdl_headData,1)+1)= "end  "+ model.opar(2) +";" ;            
              
              vhdl_headData(size(vhdl_headData,1)+1)="--****************************************************** " ;  
              
              vhdl_headData(size(vhdl_headData,1)+1)=" --VHDL compiler" ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= " ";
               
              vhdl_headData(size(vhdl_headData,1)+1)= "--Powered by scicos-hdl ZhangDong&KangCai 2008";
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= "--http://scicoshdl.sourceforge.net "  ;
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= "--****************************************************** "   ;

               if lstsize(model.opar)>7 
                   vhdl_headData=model.opar(8)
              end 
             
              Dialog_title1     =["Top Layer VHDL file ";" "];         //top title
              VHDL_Top_file     = dialog(Dialog_title1,vhdl_headData); //dialog
              vhdl_headData=[];
              Dialog_title1=[];
               
              // 2. verilog codes head

                  //`timescale 1ns/1ns
                  //module c_mux21(NXUin_1_A,NXUin_2_B,NXUin_3_S,NXUout_1_Y);
                  //input NXUin_1_A,NXUin_2_B,NXUin_3_S;
                  //output NXUout_1_Y;
                  //endmodule
              vhdl_headData=[];
              vhdl_headData(1)="// do you have some file to include ??" ;
              vhdl_headData(2)=" ";
              vhdl_headData(3)="`timescale 1ns/1ns;" ;
              vhdl_headData(4)="module"+ascii(32)+model.opar(2)+"(" ;
              
              filetemp=[];
              for i=1:  model.opar(4) // in put define
                 filetemp=[filetemp,model.opar(6)(i)];                
              end  
              filetemp=strcat(filetemp,',')
              vhdl_headData(4)=vhdl_headData(4)+filetemp;
              vhdl_headData(5)="input"+ascii(32)+filetemp+";" ;
              filetemp=[];
            
              for i=1:  model.opar(5) // out put define
                  filetemp= [filetemp,model.opar(7)(i)];                
              end   
              filetemp=strcat(filetemp,',')
              vhdl_headData(4)=vhdl_headData(4)+","+filetemp+");";
              vhdl_headData(6)="output"+ascii(32)+filetemp+";" ;
              filetemp=[];
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;  
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= " ";
              
              vhdl_headData(size(vhdl_headData,1)+1)= "add code here ...... ";
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;  
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= " ";
              
              vhdl_headData(size(vhdl_headData,1)+1)= "endmodule;" ;            
              
              vhdl_headData(size(vhdl_headData,1)+1)="--****************************************************** " ;  
              
              vhdl_headData(size(vhdl_headData,1)+1)=" --Verilog compiler" ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= " ";
               
              vhdl_headData(size(vhdl_headData,1)+1)= "--Powered by scicos-hdl ZhangDong&KangCai 2008";
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= "--http://scicoshdl.sourceforge.net " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)=" " ;
              
              vhdl_headData(size(vhdl_headData,1)+1)= "--****************************************************** " ;
              
               if lstsize(model.opar)>8 
                   vhdl_headData=model.opar(9)
               end 
              
              
              Dialog_title1     =["Top Layer Verilog file ";" "];      //top title
              Verilog_Top_file  = dialog(Dialog_title1,vhdl_headData); //dialog
              vhdl_headData=[];
              Dialog_title1=[];
              
              
              // 3. system c codes head
              
              vhdl_headData ="Plause Input the top layer System C code ";   //content
              Dialog_title1 =["Top Layer System C file ";" "];              //top title
              SystemC_Top_file = dialog(Dialog_title1,vhdl_headData);       //dialog
              vhdl_headData =[];
              Dialog_title1 =[];


              //             Dialog_content(1) ="Plause Input the top layer VHDL code ";   //content
              //             Dialog_title1     =["Top Layer VHDL file ";" "];       //top title
              //             Dialog_content(2) ="Plause Input the top layer Verilog code ";   //content
              //             Dialog_title2     =["Top Layer Verilog file ";" "];       //top title
              //             Dialog_content(3) ="Plause Input the top layer System C code ";   //content
              //             Dialog_title3     =["Top Layer System C file ";" "];       //top title
              //            
              //	           VHDL_Top_file     = dialog(Dialog_title1,Dialog_content(1));  
              //	           Verilog_Top_file  = dialog(Dialog_title2,Dialog_content(2)); 
              //	           SystemC_Top_file  = dialog(Dialog_title3,Dialog_content(3)); 
    
	           //           VHDL_Top_file     = x_dialog(Dialog_title1,Dialog_content(1));  
	           //           Verilog_Top_file  = x_dialog(Dialog_title2,Dialog_content(2)); 
	           //           SystemC_Top_file  = x_dialog(Dialog_title3,Dialog_content(3));
	           
               //** debug message('++')
               //** debug pause
               
                    
               
               IN_LONG=1;
               KKKK_IN = ["[x,y,typ]=standard_inputs(o)"];         
               WORDHH ="1";              
               KKKK_STR_IN= model.opar(6) ;  //EDIT in put port********
               KKKK_NUM_IN = size(KKKK_STR_IN);
               for ii=1:KKKK_NUM_IN(1)
                    KKKK_IN_ii = "xstring(orig(1)+2,y("+ string(ii) +")-4 ,["""+  KKKK_STR_IN(ii)  +"""]);" ;          
                    KKKK_IN =[ KKKK_IN;KKKK_IN_ii;"e=gce();e.font_foreground=11;e.font_style=0;e.background=4;"];
          
                    if IN_LONG < length(KKKK_STR_IN(ii)) then
                       IN_LONG = length(KKKK_STR_IN(ii));
                    end
              end
       
              OUT_LONG = 1;
              KKKK_OUT = ["[x,y,typ]=standard_outputs(o) "];
              KKKK_STR_OUT= model.opar(7) ;   //EDIT out put port********
              KKKK_NUM_OUT = size(KKKK_STR_OUT);
              for ii=1:KKKK_NUM_OUT(1)         
                  KKKK_OUT_ii = "xstring(orig(1)+sz(1)-5-"+ string(length(KKKK_STR_OUT(ii))*4 )  +",y("+ string(ii) +")-4 ,["""+  KKKK_STR_OUT(ii)  +"""]);" ;                            
                  KKKK_OUT =[ KKKK_OUT;KKKK_OUT_ii;"e=gce();e.font_foreground=11;e.font_style=0;e.background=4;"];        
                  if OUT_LONG < length(KKKK_STR_OUT(ii)) then
                     OUT_LONG = length(KKKK_STR_OUT(ii));
                 end         
              end                                  
             
               gr_i=[KKKK_IN ;KKKK_OUT]; // update in/out put ports name
                             
               graphics.gr_i =  gr_i;    // update block interface
             
               if( Parameters_BLOCK(4)> Parameters_BLOCK(5)) then  //edit the size of block
                   graphics.sz(2)=12 * Parameters_BLOCK(4)+6 ;
                else
                    graphics.sz(2)=12 * Parameters_BLOCK(5)+6;
               end             
                                
               graphics.sz(1)= 5 * (OUT_LONG+ IN_LONG )+10 ;
                    
               if(graphics.sz(1)<30) then 
                  graphics.sz(1) =30
               end 
             graphics.exprs = exprs1 ;  
             graphics.id = Parameters_BLOCK(3); // ID = block name
             x.graphics     = graphics;         // update the graphics of block
              
             if VHDL_Top_file==[] | VHDL_Top_file==[] | VHDL_Top_file==[] then 
               message("please input the HDL codes ");
               return;               
             else
               model.opar(8)=VHDL_Top_file;
	           model.opar(9)=Verilog_Top_file;
	           model.opar(10)=SystemC_Top_file;
                // write in the library
              pathR =[];
              pathRT=[];
              if MSDOS then
                  pathRT(1)= dirname("SCI/macros/scicos-hdl/ipcore/vhdl_ip/"+Parameters_BLOCK(3)+"/")+"\"; 
                  pathR(1) = dirname("SCI/macros/scicos-hdl/ipcore/vhdl_ip/")+"\"; 
              else
                  pathRT(1)= dirname("SCI/macros/scicos-hdl/ipcore/vhdl_ip/"+Parameters_BLOCK(3)+"/")+"/"; 
                  pathR(1) = dirname("SCI/macros/scicos-hdl/ipcore/vhdl_ip/")+"/"; 
              end  
              if MSDOS then
                  pathRT(2)= dirname("SCI/macros/scicos-hdl/ipcore/verilog_ip/"+Parameters_BLOCK(3)+"/")+"\"; 
                  pathR(2) = dirname("SCI/macros/scicos-hdl/ipcore/verilog_ip/")+"\"; 
              else
                  pathRT(2)= dirname("SCI/macros/scicos-hdl/ipcore/verilog_ip/"+Parameters_BLOCK(3)+"/")+"/"; 
                  pathR(2) = dirname("SCI/macros/scicos-hdl/ipcore/verilog_ip/")+"/"; 
              end                  
              if MSDOS then
                  pathRT(3)= dirname("SCI/macros/scicos-hdl/ipcore/system_c_ip/"+Parameters_BLOCK(3)+"/")+"\"; 
                  pathR(3) = dirname("SCI/macros/scicos-hdl/ipcore/system_c_ip/")+"\";
              else
                  pathRT(3)= dirname("SCI/macros/scicos-hdl/ipcore/system_c_ip/"+Parameters_BLOCK(3)+"/")+"/"; 
                  pathR(3) = dirname("SCI/macros/scicos-hdl/ipcore/system_c_ip/")+"/";
              end        
              //** debug message("ee")
              //** debug pause
              rmdir(pathR(1) +Parameters_BLOCK(3)); //remove the directory if it exists
              mkdir(pathR(1),Parameters_BLOCK(3)); //build a folder              
              mdelete(pathRT(1)+Parameters_BLOCK(2)+'.vhd');
              mputl(VHDL_Top_file,pathRT(1)+Parameters_BLOCK(2)+'.vhd');
            
              rmdir(pathR(2) +Parameters_BLOCK(3)); //remove the directory if it exists
              mkdir(pathR(2),Parameters_BLOCK(3)); //build a folder              
              mdelete(pathRT(2)+Parameters_BLOCK(2)+'.v');
              mputl(Verilog_Top_file,pathRT(2)+Parameters_BLOCK(2)+'.v');
            
              rmdir(pathR(3) +Parameters_BLOCK(3)); //remove the directory if it exists
              mkdir(pathR(3),Parameters_BLOCK(3)); //build a folder              
              mdelete(pathRT(3)+Parameters_BLOCK(2)+'.c');
              mputl(SystemC_Top_file,pathRT(3)+Parameters_BLOCK(2)+'.c');
            
               //** debug  message('fff')
               //** debug  pause
                
             end
             // test =2,"vhdl_file_name","block_name",2,2,["in1";"in2"],["out1";"out2"]
             x.model        = model; 
             //** debug  message("PP")
             //** debug  pause
             //xx2///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
              
             break ; //** exit point 
         end 
   
      end //** of while input loop 
 
      case 'define' then
        block_name="ip_Block";
        exprs1="2,"+ascii(34)+"vhdlfile_name"+ascii(34)+','+ascii(34)+"block_name"+ascii(34)+",inport_number,outport_number,["+ascii(34)+"in1"+ascii(34)+";"+ascii(34)+"in2"+ascii(34)+"],["+ascii(34)+"out1"+ascii(34)+";"+ascii(34)+"out2"+ascii(34)+"]";
        model = scicos_model();
        model.sim=list('zkc_hdl_ip_sim',5) ; //** computational function type 5 (Scilab)
        model.in  = [-1;-1] ;                 //** default 2 inputs
        model.out = [-1;-1] ;                 //** default one output      
        model.blocktype = 'c' ;          //** continous block type 
        model.dep_ut = [%t %f] ;  
        model.opar =list(2,"vhdl_file_name","block_name",2,2,["in1";"in2"],["out1";"out2"]);  //TYPE,TB,IN,OUT,STATE,GUI_NAME         
        //exprs =sci2exp(exprs1);                      
        exprs =exprs1;                                   
        gr_i=['dx=10;dy=10;';
              'w=sz(1)-2*dx;h=sz(2)-2*dy;';
              'txt=block_name;'
              'xstringb(orig(1)+dx,orig(2)+dy,txt,w,h,''fill'');']
       
        x = standard_define([2 2], model, exprs, gr_i)
        
       // x.model.label = "IN=" + string(2) ; //** x.graphics.id ??

end //** of select 

endfunction


//2,['a'],1,1,2,"Scilab2HDL","hdl_sci_sim" ,["1"] ,["1"] 
//ɱʽõֵ  str_sci  ʽ ,NIN_L ˿ڸ  NOUT_L ˿  // scilab for libview  //߼Ԫķ溯 ֱֵ õHDL 
//&function [get_tb_dat,state_m] = get_tb(str_sci,NIN_L,NOUT_L)  //get_tb(TXT_SCI2HDL,model.opar(3),model.opar(4))

 //ip core block has 4 dialogs, each will be : folder name, top layer file name,                                 
           
// 3,['00','00','01','01','10','10','11','11';'0','1','0','1','0','1','0','1';'0','1','0','0','1','1','1','0'],4,1,8,"JKtrigger_cr",
// '01','0','cr1' ,['IN1';'IN2';'IN3';'IN4'],['OUT1'] 
           
// --code dialog model
//symbol of sequential ciruit,[truth table],inports,outports,states,"name",'01clk','0','cr1' ,['IN1';'IN2';'IN3';'IN4'],['OUT1'] 
//1. drawing you sequential circuit state dialog
//2. make sure how many states there will be and use "A,B,C..." as A=000, B=010 and so on
//3. link every state and mark every link as "A-->B 1;  B-->C 2, E-->A n"
//4. make sure : link1 - in1, link2 -in2, link3 - in3,
//state 1="000", state 2="101", state 3="011", state n="111"
//statelst(state_number)=["state 1","state 2","state 3","...state n"] save the states of the circuit 
//linkmat(1)=[state1 -> state2 /in1]
//linkmat(2)=[state2 -> state3 /in2]
//linkmat(3)=[state4 -> state5 /in4]
//linkmat(n)=[state(n-1) -> state(n) /in(n)]
//----end

//states=["000","010","101","110","111"];
//linkmat=list(); --> this one i shoul think??  let user write their truth table easier
//linkmat(1)=list(1,2,"00");
//linkmat(2)=list(2,3,"01");
//linkmat(3)=list(3,4,"10");
//linkmat(4)=list(4,5,"11");
//linkmat(5)=list(5,1,"00");
//linkmat(6)=list(5,2,"01");
//linkmat(7)=list(1,3,"00");

 //& t_b=[];
 
 //& execstr(str_sci);
  
  //&for i=1:lstsize(linkmat)
    //&  t_b(1,i)=linkmat(i)(3);
     //& t_b(2,i)=states(linkmat(i)(1));
     //& t_b(3,i)=states(linkmat(i)(2));
  //&end  
  //&t_b
  //&get_tb_dat=t_b;  //truth table 
  //&state_m=lstsize(linkmat); // the number of states
 
  
//&endfunction


