function [x,y,typ] = hdl_st_interf(job,arg1,arg2)
//zd&kc scicos-hdl 0.5 2008
x=[];y=[];typ=[];

select job
  
  case 'plot' then
      block_name=arg1.model.opar(2)
      standard_draw(arg1)

  case 'getinputs' then
      [x,y,typ]=standard_inputs(arg1)
      //    message('getinputs')
     
  case 'getoutputs' then
      [x,y,typ]=standard_outputs(arg1)
      //  message('getoutputs')
      
  case 'getorigin' then
      [x,y]=standard_origin(arg1)
      //message('getorigin')
      
  case 'set' then
      // ** debug  message("ppp")
      global kczd_scicos_hdl_set ;    // control the dialog 
      if  kczd_scicos_hdl_set ==0 then
          x = arg1;
          return;
      end
        
      x = arg1;
      graphics  = arg1.graphics 
      exprs1    = graphics.exprs
      model     = arg1.model
      
      while %t do
           
           [ok,exprs1] = getvalue('Set Parameters ','Parameters:', list('str',-1), exprs1) ;         
           
           //opar =list(3,"block_name",'clk(01/10)','cr(1/0)',4,1,["clk";"D"],["q";"q!"],["INstate";"Qn";"Qn+1"],state_num);
           if ~ok then
              break ;     //** exit point 
           end

           Parameters_BLOCK = list();
  
           execstr("Parameters_BLOCK=list("+exprs1+")");
           
           nin=-ones(Parameters_BLOCK(5),1)             
           out=-ones(Parameters_BLOCK(6),1);                               
                      
           // verify that the block parameters are OK 
           [model, graphics, ok] = check_io(model, graphics, nin, out, [], [])
           
           if ~ok then
              break;
           end

           //xx1////////////////////////////////////////////////////////  

           if ok then 
	           
	           //states=["000","010","101","110","111"];
               //linkmat=list(); --> this one i shoul think??  let user write their truth table easier
               //linkmat(1)=list(1,2,"00");
               //linkmat(2)=list(2,3,"01");
               //linkmat(3)=list(3,4,"10");
               //linkmat(4)=list(4,5,"11");
               //linkmat(5)=list(5,1,"00");
               //linkmat(6)=list(5,2,"01");
               //linkmat(7)=list(1,3,"00");

              // model.opar  = Parameters_BLOCK ; //number of inputs 
               
               model.opar(1)  = Parameters_BLOCK(1) ; //number of inputs 
               model.opar(2)  = Parameters_BLOCK(2) ; //number of inputs 
               model.opar(3)  = Parameters_BLOCK(3) ; //number of inputs 
               model.opar(4)  = Parameters_BLOCK(4) ; //number of inputs                
               model.opar(5)  = Parameters_BLOCK(5) ; //number of inputs 
               model.opar(6)  = Parameters_BLOCK(6) ; //number of inputs 
               model.opar(7)  = Parameters_BLOCK(7) ; //number of inputs 
               model.opar(8)  = Parameters_BLOCK(8) ; //number of inputs 
               
               //message(string(lstsize(model.opar)))
               if lstsize(model.opar)<11
                   V_SHOW_P ="please input the state code";  
               else
                   V_SHOW_P=model.opar(11)
               end                
               
               //V_SHOW_P    ="please input the state code";  
               V_SHOW      =["State Code for Squential Circuit ";" "];
               TXT_SCI2HDL = dialog(V_SHOW,V_SHOW_P);    // get the code of FSM
               
               // ** debug  message(TXT_SCI2HDL)
               // ** debug  pause
                    
               IN_LONG=1
               KKKK_IN = ["[x,y,typ]=standard_inputs(o)"];         
               WORDHH ="1";              
               KKKK_STR_IN= model.opar(7) ;  //EDIT********
               KKKK_NUM_IN = size(KKKK_STR_IN);
               for ii=1:KKKK_NUM_IN(1)
                    KKKK_IN_ii = "xstring(orig(1)+2,y("+ string(ii) +")-4 ,["""+  KKKK_STR_IN(ii)  +"""]);"           
                    KKKK_IN =[ KKKK_IN;KKKK_IN_ii;"e=gce();e.font_foreground=11;e.font_style=0;e.background=4;"]
          
                    if IN_LONG < length(KKKK_STR_IN(ii)) then
                       IN_LONG = length(KKKK_STR_IN(ii))
                    end
              end
       
              OUT_LONG = 1
              KKKK_OUT = ["[x,y,typ]=standard_outputs(o) "];
              KKKK_STR_OUT= model.opar(8) ;   //EDIT********
              KKKK_NUM_OUT = size(KKKK_STR_OUT);
              for ii=1:KKKK_NUM_OUT(1)         
                  KKKK_OUT_ii = "xstring(orig(1)+sz(1)-5-"+ string(length(KKKK_STR_OUT(ii))*4 )  +",y("+ string(ii) +")-4 ,["""+  KKKK_STR_OUT(ii)  +"""]);"                             
                  KKKK_OUT =[ KKKK_OUT;KKKK_OUT_ii;"e=gce();e.font_foreground=11;e.font_style=0;e.background=4;"]        
                  if OUT_LONG < length(KKKK_STR_OUT(ii)) then
                     OUT_LONG = length(KKKK_STR_OUT(ii))
                 end         
              end                                  
             
              gr_i=[KKKK_IN ;KKKK_OUT]
                             
              graphics.gr_i =  gr_i
             
              if( Parameters_BLOCK(5)> Parameters_BLOCK(6)) then
                  graphics.sz(2)=12 * Parameters_BLOCK(5)+6 ;
              else
                  graphics.sz(2)=12 * Parameters_BLOCK(6)+6;
              end             
                                
              graphics.sz(1)= 5 * (OUT_LONG+ IN_LONG )+10 ;
                    
              if(graphics.sz(1)<30) then 
                 graphics.sz(1) =30
              end 
             
             //graphics.exprs = exprs1 ;
             //graphics.id    = Parameters_BLOCK(2);
             //x.graphics     = graphics;
              
             if TXT_SCI2HDL==[] then 
               //** debug message("please input the HDL codes ");
               //** debug return;  
             else            
               [model.opar(9),model.opar(10)] = get_stb(TXT_SCI2HDL,model.opar(5),model.opar(6))   
               //message('++')
               //pause
             end
        
             model.opar(11)=TXT_SCI2HDL;
             graphics.exprs = exprs1;
             graphics.id    = Parameters_BLOCK(2);
             x.graphics     = graphics;
             x.model        = model; 
             
             //xx2///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
             break ; //** exit point 
         end 
   
      end //** of while input loop 
 
      case 'define' then
        
        //opar =list(3,"block_name",'clk(01/10)','cr(1/0)',4,1,["clk";"D"],["q";"q!"],["INstate";"Qn";"Qn+1"],state_num);
        
        block_name="TB_Block";
        
        exprs1="3,"+ascii(34)+"block_name"+ascii(34)+","+ascii(34)+"clk(01/10)"+ascii(34)+","+ascii(34)+"clr(1/0)"+ascii(34)+",inport_number,outport_number,["+ascii(34)+"clk"+ascii(34)+";"+ascii(34)+"D"+ascii(34)+"],["+ascii(34)+"Q"+ascii(34)+";"+ascii(34)+"Q!"+ascii(34)+"]";                     
        
        model = scicos_model();
        model.sim=list('hdl_st_sim',5) ; //** computational function type 5 (Scilab)
        model.in  = [-1;-1] ;            //** default 2 inputs
        model.out = [-1;-1] ;            //** default one output      
        model.blocktype = 'c' ;          //** continous block type 
        model.dep_ut = [%t %f] ;  
        model.opar =list(3,"block_name","clk(01/10)","clr(1/0)",2,2,["clk";"D"],["q";"q!"]);  //TYPE,TB,IN,OUT,STATE,GUI_NAME         
        exprs = exprs1;           
                                          
        gr_i=['dx=10;dy=10;';
              'w=sz(1)-2*dx;h=sz(2)-2*dy;';
              'txt=block_name;'
              'xstringb(orig(1)+dx,orig(2)+dy,txt,w,h,''fill'');']
       
        x = standard_define([2 2], model, exprs, gr_i)
        
       // x.model.label = "IN=" + string(2) ; //** x.graphics.id ??
       
end //** of select 

endfunction


//2,['a'],1,1,2,"Scilab2HDL","hdl_sci_sim" ,["1"] ,["1"] 
//ɱʽõֵ  str_sci  ʽ ,NIN_L ˿ڸ  NOUT_L ˿  // scilab for libview  //߼Ԫķ溯 ֱֵ õHDL 
function [get_tb_dat,state_m] = get_stb(str_sci,NIN_L,NOUT_L)  //get_tb(TXT_SCI2HDL,model.opar(3),model.opar(4))
           
// --code dialog model
//symbol of sequential ciruit,[truth table],inports,outports,states,"name",'01clk','0','cr1' ,['IN1';'IN2';'IN3';'IN4'],['OUT1'] 
//1. drawing you sequential circuit state dialog
//2. make sure how many states there will be and use "A,B,C..." as A=000, B=010 and so on
//3. link every state and mark every link as "A-->B 1;  B-->C 2, E-->A n"
//4. make sure : link1 - in1, link2 -in2, link3 - in3,
//state 1="000", state 2="101", state 3="011", state n="111"
//statelst(state_number)=["state 1","state 2","state 3","...state n"] save the states of the circuit 
//linkmat(1)=[state1 -> state2 /in1]
//linkmat(2)=[state2 -> state3 /in2]
//linkmat(3)=[state4 -> state5 /in4]
//linkmat(n)=[state(n-1) -> state(n) /in(n)]
//----end

//states=["000","010","101","110","111"];
//linkmat=list(); --> this one i shoul think??  let user write their truth table easier
//linkmat(1)=list(1,2,"00");
//linkmat(2)=list(2,3,"01");
//linkmat(3)=list(3,4,"10");
//linkmat(4)=list(4,5,"11");
//linkmat(5)=list(5,1,"00");
//linkmat(6)=list(5,2,"01");
//linkmat(7)=list(1,3,"00");

// ** debug message("q")
  t_b=[];
 
  execstr(str_sci);
  
  for i=1:lstsize(linkmat)
      t_b(1,i)=linkmat(i)(3);
      t_b(2,i)=states(linkmat(i)(1));
      t_b(3,i)=states(linkmat(i)(2));
  end  
  t_b
  get_tb_dat=t_b;  //truth table 
  state_m=lstsize(linkmat); // the number of states
 
  
  
endfunction


