function [x,y,typ] = kcctb(job,arg1,arg2)
//zd&kc 2008
x=[];y=[];typ=[];

select job
  
  case 'plot' then
      block_name=arg1.model.opar(6)
      standard_draw(arg1)

  case 'getinputs' then
      [x,y,typ]=standard_inputs(arg1)
  
  case 'getoutputs' then
      [x,y,typ]=standard_outputs(arg1)
    
  case 'getorigin' then
      [x,y]=standard_origin(arg1)
     
  case 'set' then
    
      global kczd_scicos_hdl_set ;    
      if  kczd_scicos_hdl_set ==0 then
          x = arg1;
          return;
      end
    
      x = arg1;
      graphics  = arg1.graphics 
      exprs1    = graphics.exprs
      model     = arg1.model

      while %t do
           
           [ok,exprs1] = getvalue('Set Parameters ','Parameters:', list('str',-1), exprs1)          
           //list(1,['0','1';'00','11'],1,2,2,"LineDemux"); //2   
           if ~ok then
              break ; //** exit point 
           end

           Parameters_BLOCK = list();
  
           execstr("Parameters_BLOCK=list("+exprs1+")");
           nin=-ones(Parameters_BLOCK(3),1)             
           out=-ones(Parameters_BLOCK(4),1);         
                      
           // verify that the block parameters are OK 
           [model, graphics, ok] = check_io(model, graphics, nin, out, [], [])
           
           //xx1//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
           if ok then 
               model.opar     = Parameters_BLOCK ; //number of inputs  
               graphics.exprs = exprs1 ;                                
               IN_LONG=1
               KKKK_IN = ["[x,y,typ]=standard_inputs(o)"];         
               WORDHH ="1";              
               KKKK_STR_IN= model.opar(7) ;  //EDIT********
               KKKK_NUM_IN = size(KKKK_STR_IN);
               for ii=1:KKKK_NUM_IN(1)
                    KKKK_IN_ii = "xstring(orig(1)+2,y("+ string(ii) +")-4 ,["""+  KKKK_STR_IN(ii)  +"""]);"           
                    KKKK_IN =[ KKKK_IN;KKKK_IN_ii;"e=gce();e.font_foreground=11;e.font_style=0;e.background=4;"]
          
                    if IN_LONG < length(KKKK_STR_IN(ii)) then
                       IN_LONG = length(KKKK_STR_IN(ii))
                    end
              end
       
              OUT_LONG = 1
              KKKK_OUT = ["[x,y,typ]=standard_outputs(o) "];
              KKKK_STR_OUT= model.opar(8) ;   //EDIT********
              KKKK_NUM_OUT = size(KKKK_STR_OUT);
              for ii=1:KKKK_NUM_OUT(1)         
                  KKKK_OUT_ii = "xstring(orig(1)+sz(1)-5-"+ string(length(KKKK_STR_OUT(ii))*4 )  +",y("+ string(ii) +")-4 ,["""+  KKKK_STR_OUT(ii)  +"""]);"                             
                  KKKK_OUT =[ KKKK_OUT;KKKK_OUT_ii;"e=gce();e.font_foreground=11;e.font_style=0;e.background=4;"]        
                  if OUT_LONG < length(KKKK_STR_OUT(ii)) then
                     OUT_LONG = length(KKKK_STR_OUT(ii))
                 end         
              end                                  
             
               gr_i=[KKKK_IN ;KKKK_OUT]
                             
               graphics.gr_i =  gr_i
             
               if( Parameters_BLOCK(3)> Parameters_BLOCK(4)) then
                   graphics.sz(2)=12 * Parameters_BLOCK(3)+6 ;
               else
                    graphics.sz(2)=12 * Parameters_BLOCK(4)+6;
               end             
                                
               graphics.sz(1)= 5 * (OUT_LONG+ IN_LONG )+10 ;
                    
               if(graphics.sz(1)<30) then 
                     graphics.sz(1) =30
               end 
             
             graphics.id = Parameters_BLOCK(6);
             x.graphics     = graphics;
             x.model        = model; 
             //xx2///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
             
             break ; //** exit point 
         end 
   
      end //** of while input loop 
 
      case 'define' then
        block_name="TB_Block";
        exprs1="1,"+"["+ascii(34)+"truthtable"+ascii(34)+"]"+","+"inport_num,outport_num,state_num,"+ascii(34)+"block_name"+ascii(34)+",["+ascii(34)+"clk"+ascii(34)+";"+ascii(34)+"D"+ascii(34)+"],["+ascii(34)+"Q"+ascii(34)+";"+ascii(34)+"Q!"+ascii(34)+"]"; 
        model = scicos_model();
        model.sim=list('hdl_tb_sim',5) ; //** computational function type 5 (Scilab)
        model.in  = -1 ; //** default 2 inputs
        model.out = [-1;-1] ; //** default one output      
        model.blocktype = 'c' ; //** continous block type 
        model.dep_ut = [%t %f] ;  
        model.opar =list(1,['0','1';'00','11'],1,2,2,"test",['IN1'],['OUT1';'OUT2']);  //TYPE,TB,IN,OUT,STATE,GUI_NAME         
        exprs = exprs1;
                           
                                          
         gr_i=['dx=10;dy=10;';
              'w=sz(1)-2*dx;h=sz(2)-2*dy;';
              'txt=block_name;'
              'xstringb(orig(1)+dx,orig(2)+dy,txt,w,h,''fill'');']
       
        x = standard_define([2 2], model, exprs, gr_i)
        
       // x.model.label = "IN=" + string(2) ; //** x.graphics.id ??

end //** of select 

endfunction
