function [x,y,typ]=xbinnxu(job,arg1,arg2)
// Copyright INRIA
x=[];y=[];typ=[];
select job
 case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then
  x=arg1;
  graphics=arg1.graphics;
  model=arg1.model;

  while %t do
  [ok,prt]=getvalue('Set Input NUM','Port NUM',list('vec',1),string(graphics.exprs))
  
    if ~ok then break,end
   
    graphics.exprs=sci2exp(prt);  
   
    out=-ones(prt,1);
    nin=-ones(prt,1);     
    
    [model, graphics, ok] = check_io(model, graphics, nin, out, [1], [])

     
    graphics.sz(2)=7 * prt+6 ; 
         
       if(   graphics.sz(2)<30) then
        
         graphics.sz(2) =30
         
       end
                    
  
    x.graphics     = graphics;
    x.model        = model; 
    
           
    
    break;
    
  end
case 'define' then

  model=scicos_model()
  model.sim=list('zbsnxu',5)
  model.in=-1
  model.out=-1
  //model.evtout=1
  model.evtin=1;                   //event input
  model.dstate=0; 
  model.blocktype = 'd' ;          //** continous block type 
  model.dep_ut = [%t %f] ; 

  exprs="1";
  
 gr_i=['xstringb(orig(1),orig(2),[''OUT''],sz(1),sz(2),''fill'')']
 
    
  x=standard_define([2 1],model,exprs,gr_i)
  
end
endfunction
