  
`include "hamdec.v"

module hamdecnxu( in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,in_10,in_11,
              in_12,out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8,out_9);

input in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,in_10,in_11,in_12;
output out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8,out_9;

    wire [7:0] nxu_in1;
    wire [3:0] nxu_in2;
    wire [7:0] nxu_out1; 
 
assign nxu_in1 = {in_5,in_6,in_7,in_8,in_9,in_10,in_11,in_12};
assign nxu_in2 = {in_1,in_2,in_3,in_4};
 
hamdec map0618(.ham_in(nxu_in2),.data_in(nxu_in1),
                  .data_out(nxu_out1),.errork(out_9));
assign {out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8} = nxu_out1;
  
endmodule

//******************************************************
 //Copyright NXU AGL (2004-2007)
 
 //Powered by scicos-hdl 0.4 ZhangDong&KangCai 2007 NXU
 
 //http://scicoshdl.sourceforge.net
 
//******************************************************

