
`include "muxBUS_2.v"
 module muxBUS_2nxu(in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,out_1,out_2,
                    out_3,out_4,out_5,out_6,out_7,out_8,out_9,out_10,out_11,
                    out_12,out_13,out_14,out_15,out_16);
 
 input in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9;
 
  output out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8;
 
  output out_9,out_10,out_11,out_12,out_13,out_14,out_15,out_16;
  
  wire [7:0] nxu_in1; 
  
  wire [7:0] nxu_out1,nxu_out2; 
 
  assign nxu_in1 = {in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9};

 muxBUS_2 map(.s1(in_1),.data(nxu_in1),.y1(nxu_out1),.y2(nxu_out2));
 
 assign {out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8} = nxu_out1;

 assign {out_9,out_10,out_11,out_12,out_13,out_14,out_15,out_16} = nxu_out2;
 
 endmodule


  //******************************************************
  //Copyright NXU AGL (2004-2007)
 
  //Powered by scicos-hdl 0.4 ZhangDong&KangCai 2007 NXU
 
  //http://scicoshdl.sourceforge.net
 
 //******************************************************
