
`include "muxBUS_3.v"
module muxBUS_3nxu(in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,
              in_10,out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8,
              out_9,out_10,out_11,out_12,out_13,out_14,out_15,out_16,
              out_17,out_18,out_19,out_20,out_21,out_22,out_23,out_24);
  input in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,in_10;
  output out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8;
  output out_9,out_10,out_11,out_12,out_13,out_14,out_15,out_16;
  output out_17,out_18,out_19,out_20,out_21,out_22,out_23,out_24;
  wire [7:0] nxu_in1; 
  wire [7:0] nxu_out1,nxu_out2,nxu_out3; 

assign nxu_in1 = {in_3,in_4,in_5,in_6,in_7,in_8,in_9,in_10};

muxBUS_3 map(.s1(in_1),.s2(in_2),.data(nxu_in1),.y1(nxu_out1),.y2(nxu_out2),
             .y3(nxu_out3));

assign {out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8}=nxu_out1;
assign {out_9,out_10,out_11,out_12,out_13,out_14,out_15,out_16}=nxu_out2;
assign {out_17,out_18,out_19,out_20,out_21,out_22,out_23,out_24}=nxu_out3;

endmodule

//******************************************************
 //Copyright NXU AGL (2004-2007)
 
 //Powered by scicos-hdl 0.4 ZhangDong&KangCai 2007 NXU
 
 //http://scicoshdl.sourceforge.net
 
//******************************************************
