//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Convert Administrater ==============\\

function r=Verilog_B_Admin(data,num,path)  //Convert Administrater

 rapaD=list();              //every block's VHDL data parameter

 for i=1:num


    rapaD(i)=data(i)(6)   //data-->every block VHDL's parameters
                          //come from truthtable_IDC

 end

 for k=1:num

   select rapaD(k)(1)    //the type of block

     case 1 then Type1=Verilog_convert_Com(rapaD(k),path)    //sys circuit

     case 3 then Type1=Verilog_convert_Seq(rapaD(k),path)   //timt circuit

     case 2 then Type1=Verilog_convert_IPcore(rapaD(k),path)  //IP core 
  
     else message('add other block type')
          break;

   end

 end
  
 r='ok'                
  
 //endfunction

 
