//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//===============Main function -->verilog==============\\


function kczd_V=Verilog_compiler(Cos_path,Verilog_path)  //Analyse the.COS file:Block/link

//==========================================================================================
  
fileName=scs_m.props(3)(1);          //file name


  if length(Verilog_path)<4
      pathtmp=scs_m.props(3)(2);          //vhdl file path
  else
      pathtmp=Verilog_path;
  end

  filePath=pathtmp;
  
//==========================================================================================

//nxu_embBLK=scs_m.objs;                //cos data
//
//nxu_embBLK_num=length(nxu_embBLK);    //block and link num
//
//nxu_emb_LINKC_N=0;                    //Link number
//nxu_emb_BLOCKC_N=0;                   //block number

inport=0;                             //The number of inports
outport=0;                            //The number of outports
com_number=0;                         //the number of blocks

L_num=0;                              //the link  total number
B_num=0;                              //the block tatal number

nxu_emb_LINKA=list();      //the l_b list engaged in simulation

B_Data=list();             //the function list of blocks
L_Data=list();             //the relationship of all blocks

embin_data=list();         //embin  list
embout_data=list();        //embout list

kczd_block=list();         //block  list

final_data=list();         //our library info

block_lmp=list();          //block map data

filter_D=list();           //filter data
  
nxu_emb_BLOCKA=list();     //the simulation blocks list (unused for future)

//=============================================================================================

//for i=1:nxu_embBLK_num    //depart the data of block and link
//
//  nxu_b_Type=getfield(1,nxu_embBLK(i));
//        
//  if nxu_b_Type(1)=='Link'                           //Link depart
//     nxu_emb_LINKC_N=nxu_emb_LINKC_N+1;
//     L_Data(nxu_emb_LINKC_N)=VerilogLink(nxu_embBLK(i));
//  end 
//        
//  if nxu_b_Type(1)=='Block'                          //Block depart
//     nxu_emb_BLOCKC_N=nxu_emb_BLOCKC_N+1;
//     B_Data(nxu_emb_BLOCKC_N)=VerilogBlock(i,nxu_embBLK(i));
//  end
//
//end
//
//L_num=nxu_emb_LINKC_N;            //link number
//B_num=nxu_emb_BLOCKC_N;           //block number

//==============================================================================================

[blklst,cmat,ccmat,cor,corinv,ok,scs_m,flgcdgen,freof]=c_pass1(scs_m,-1);  //** get the information of every block 

[blklst,cmat]=scicoshdl_format(blklst,cmat);  //deal with the split thing


//** blklst --> block data
//** cmat   --> regular link, from-> to 
//** ccmat  --> event link, from-> to

//[Blk_Info_all,Link_info_all]=get_all_info(blklst,cmat)

IP_Blk_sim='';  //** IPcore computing function

for i=1:lstsize(blklst)    //  filter the entity blocks
    
   IP_Blk_sim=strindex(blklst(i).sim(1),"zkc_");
    
   if blklst(i).sim(1)=="hdl_tb_sim" | blklst(i).sim(1)=="hdl_st_sim" | blklst(i).sim(1)=="scicoshdlport" | IP_Blk_sim(1)==1 then  
        
        kczd_block(lstsize(kczd_block)+1)=VerilogBlock(i,blklst(i),cmat)
        
   end 
   
end  //end of lstsize(blklst)

Link_Num=[];

L_Data=VerilogLink(cmat);
L_num=lstsize(L_Data);            //link number
com_number=lstsize(kczd_block);           //block number
//message(string(com_number))
//==============================================================================================

//My_library=library();        //link the blocks librarys
//                             //Administrate when add or decrease the block library
//My_numbers=size(My_library); //get the size of lib
//
//lib_num=My_numbers(2);       
//com_mynum=0;
//
//for i=1: B_num
//  for j=1:lib_num
//    if B_Data(i)(2)==My_library(j); //if it is our lib' blocks
//                                    //save all nessesrary data in 'kczd_block'
//        com_number=com_number+1;
//
//        kc1=B_Data(i)(1);
//        kc2=B_Data(i)(2);
//        kc3=B_Data(i)(3);
//        kc4=B_Data(i)(4);
//        kc5=B_Data(i)(5);
//        kc6=B_Data(i)(6);
//        kc7=B_Data(i)(7);
//        kc8=B_Data(i)(8);
//        kc9=B_Data(i)(9);
//
//        kczd_block(com_number)=list(kc1,kc2,kc3,kc4,kc5,kc6,kc7,kc8,kc9);
//       // message(string(kc1)+'*'+string(kc2)+'*'+string(kc3)+'*'+string(kc4)+'*'+string(kc5)+'*'+string(kc6)+'*'+string(kc7)+'*'+string(kc8)+'*'+string(kc9)+'*'+'------------------------------------2')
//  
//    end
//  end
//end  

//================================================================================================
portCounter=0;

for scicoshdlPort=1:com_number 
  
    if (kczd_block(scicoshdlPort)(2)=='embin') | (kczd_block(scicoshdlPort)(2)=='embout') then
       portCounter=portCounter+1;
    end 
  
end  
//message(string(portCounter))

if portCounter > 0 then // if in/out block is in the file
  //message("thishah")
  
  com_mynum=0; //block counter
//================================================================================================
 
  for i=1:com_number                          //components categories

        name_com=kczd_block(i)(2);
   
        if name_com=='embin'               //in port components

            inport=inport+1;               //get the tatol number

            [IN_symbol(inport),embin_data(inport)]=Verilog_in(kczd_block(i));

         elseif name_com=='embout'          //out port components

            outport=outport+1;              //get the tatol number

            [OUT_symbol(outport),embout_data(outport)]=Verilog_out(kczd_block(i));  

         else                               //entity components

            com_mynum=com_mynum+1;          //get the tatol number

            final_data(com_mynum)=Block_analyse(kczd_block(i));

        end
  end 

//========================================================================================================================

  [filter_D,filter_num]=Verilog_filter(final_data,com_mynum); //filter:be sure no same components in

//========================================================================================================================

  Every_B=Verilog_B_Admin(filter_D,filter_num,filePath); //block vhdl code generator administrator

                       //filter_D  : all the parameters of every blocks

                       //filter_num: tatol number of blocks in your model file 

                     //filePath  : form:"/root/Desktop/tmp/"-->where users save there files(path)
//==========================================================================================================================
 
  includeD=Vrelog_INc(filter_D,filter_num)  //include file_data ok

//==========================================================================================================================

  [ninM,outM,indefine,outdefine]=portTop(inport,outport,IN_symbol,OUT_symbol);             //for the top file

//==========================================================================================================================

  [wire_B,ass_B]=wire_map(final_data,com_mynum); //for the top file-->component map

//==========================================================================================================================

  wirein=wire_mapEI(embin_data,inport,IN_symbol);            //top file-->IN&wire map

//==========================================================================================================================

  [wireOut,ass_Out]=wire_mapEO(embout_data,outport,OUT_symbol);//top file-->OUT&signal map

//==========================================================================================================================

  TestbenchV=testbench_verilog(inport,outport,fileName,filePath,IN_symbol,OUT_symbol)  //test bench

//==========================================================================================================================

  fileinfoVe=forUsersVe(final_data,com_mynum);  //doc

  //filedoc=blockDocVerilog(fileName,filePath,filter_D,filter_num,fileinfoVe);    //doc 
//==========================================================================================================================

//**************************~~~~~~~~~~~~~~~~~*********************************************************
//**************************~!Verilog TOP  !~*************************************
//**************************~!   NXU AGL   !~*************************************
//**************************~!ZD--KC 2006-3!~*************************************
//**************************~~~~~~~~~~~~~~~~~*********************************************************

  //ninM=splitintoline(ninM);
  //outM=splitouttoline(outM);

  timeD=ascii(96)+'timescale'+ascii(32)+'1ns'+ascii(47)+'1ns'
  header='module'+ascii(32)+fileName+ascii(40)+ninM+','+outM+ascii(41)+ascii(59);
  //header='module'+ascii(32)+fileName+ascii(40)+ascii(41)+ascii(59);
  endpp='endmodule';

  //cosp(1)="// Copyright NXU AGL 2006.3";    2007.3.4  canceal this 
  cosp=ascii(32);
  Copyright='';
  Copyright==mgetl('SCI/macros/scicos-hdl/verilog/Copyrightverilog.txt'); //symbol of victory


  topF='';
  topF=[cosp;includeD;timeD;header;indefine;outdefine;wire_B;wireOut;wirein;ass_B;ass_Out;endpp;Copyright]; //˸Ķ  kkkkkkkkkkkkkk

  VerilogLANtopKC='';
  VerilogLANtopKC=spitline(topF);

  //write(filePath+fileName+'.v',VerilogLANtopKC);
  mdelete(filePath+fileName+'.v');
  mputl(VerilogLANtopKC,filePath+fileName+'.v');

//==========================================================================================================================

  kczd_V='ok'; //compiler ok

//------------------------------------

else
    //message("please put Input\Output block in");
   
    kczd_V='exit'; //compiler failed
    return;
    
end  
  
mclose('all'); 

endfunction
