//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//==============Scicos-HDL -->START====================\\

function OK=Verilog_start(cos_File_path,verilog_File_path)         //start EMB

  getf(SCI+'/macros/scicos-hdl/verilog/Verilog_compiler.sci');     //数据读取 总模?

  getf(SCI+'/macros/scicos-hdl/verilog/VerilogLink.sci');          //元件数据分?器
     
  getf(SCI+'/macros/scicos-hdl/verilog/VerilogBlock.sci');         //连线数据分?器

  getf(SCI+'/macros/scicos-hdl/verilog/library.sci');              //联接元件?

  getf(SCI+'/macros/scicos-hdl/verilog/Verilog_in.sci');           //输出元件解析噡

  getf(SCI+'/macros/scicos-hdl/verilog/Verilog_out.sci');          //输入元件解析噡

  getf(SCI+'/macros/scicos-hdl/verilog/Block_analyse.sci');        //实体元件解析噡
 
  getf(SCI+'/macros/scicos-hdl/verilog/Verilog_filter.sci');       //库元件过滤器

  getf(SCI+'/macros/scicos-hdl/verilog/Verilog_B_Admin.sci');      //元件编译管理噡

  getf(SCI+'/macros/scicos-hdl/verilog/Verilog_convert_Com.sci');   //组合逻辑 元件编译噡

  getf(SCI+'/macros/scicos-hdl/verilog/Verilog_convert_Seq.sci');   //时序逻辑 元件编译噡

  getf(SCI+'/macros/scicos-hdl/verilog/Verilog_convert_IPcore.sci'); //IPcore 元件编译噡
  
  getf(SCI+'/macros/scicos-hdl/verilog/splitintoline.sci'); //IPcore 元件编译噡
  
   getf(SCI+'/macros/scicos-hdl/verilog/spitline.sci'); //IPcore 元件编译噡

  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  getf(SCI+'/macros/scicos-hdl/verilog/Vrelog_INc.sci');  //include file

  getf(SCI+'/macros/scicos-hdl/verilog/portTop.sci');     //顶层文件 实体?口生成器

  getf(SCI+'/macros/scicos-hdl/verilog/wire_map.sci');    //顶层文件 元件映射衡

  getf(SCI+'/macros/scicos-hdl/verilog/wire_mapEI.sci');  //顶层文件 输入?口映射表

  getf(SCI+'/macros/scicos-hdl/verilog/wire_mapEO.sci');  //顶层文件 输出?口映射表

  //======================================================================================

  getf(SCI+'/macros/scicos-hdl/verilog/testbench_verilog.sci');  //test bench

  getf(SCI+'/macros/scicos-hdl/verilog/testIO_verilog.sci');     //test bench

  //======================================================================================


  getf(SCI+'/macros/scicos-hdl/verilog/forUsersVe.sci');        //doc 

  getf(SCI+'/macros/scicos-hdl/verilog/blockDocVerilog.sci');        //doc  
  
 //================================================================================================
  
  getf(SCI+'/macros/scicos-hdl/verilog/scs_all_supper2block.sci")  //super blocks
  
  getf(SCI+'/macros/scicos-hdl/verilog/nxu_s2p_one.sci")
  getf(SCI+'/macros/scicos-hdl/verilog/cos2cosfoo.sci')
  getf(SCI+'/macros/scicos-hdl/verilog/clearDeleted.sci')
  getf(SCI+'/macros/scicos-hdl/verilog/updateBlocklink.sci')

  getf(SCI+'/macros/scicos-hdl/scicoshdl_format.sci')


  //=========================================================================================

  verilog_File_Fpath=verilog_File_path+'/'

  kczd_testVe=Verilog_compiler(cos_File_path,verilog_File_Fpath)  //run verilog compiler
 
//===================================================================================================

  //message(string(kczd_test))
  if string(kczd_testVe)=='ok' then
  
//========================================================================================

 p1=' >>  HDL Project Path : '+verilog_File_Fpath+'.';
 p2=' >>  Note : We save your vhdl in the defaut path.';
 p3=' >>  Scicos-HDL 0.5  Copyright (c) 2004-2008';
 p4=' >>  ZhangDong&KangCai (NXU, LIAMA, INRIA) '
 p6=' >>  Project Compiled 100% '
 
 LPline=''; 
 Lp1=length(p1);
 Lp2=length(p2);
 if Lp2 > Lp1 then
    for i =1:Lp2+Lp2-10
        LPline=LPline+'-';
    end 
 else
    for i =1:Lp1+Lp1-10
        LPline=LPline+'-';
    end 
 end

 if length(verilog_File_path)<4

      verilog_File_path=verilog_File_path+' dose not exist!'
      message([' ';p2;LPline;p3;LPline;p4;LPline])
 else
      message([' ';p6;LPline;p1;LPline;p3;LPline;p4;LPline])
    
 end

 OK='!!Scicos-HDL -- OK done !!';
 
 else
  
 message(["Please put Input\Output block in your file !";"Scicos-HDL Compiler exit !"]); 
 OK='exit';
 return;
 
end 
 endfunction
