//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//===============file    -->hdl==============\\


function ReUsVe=forUsersVe(infoDve,infoNumve,filePpve)  //doc
   
 fileIve=list();              //every block's VHDL data parameter

 comBNve=0;
 comDAve='';
 squBNve=0;
 squDAveve='';
 IPcBNve=0;
 ipcDAve='';

 for i=1:infoNumve

    fileIve(i)=infoDve(i)(6)   //data-->every block VHDL's parameters
                          //come from truthtable_IDC
 end

 for k=1:infoNumve

    if fileIve(k)(1)==1
       comBNve=comBNve+1;  //record the comBlocks number
    elseif fileIve(k)(1)==3
       squBNve=squBNve+1;
    else
       IPcBNve=IPcBNve+1;
    end
 end

 if comBNve>=1
    comDAve=string(comBNve)+'-Combinational-block';
 else
    comDAve='no Combinational block';
 end

 if squBNve>=1
    squDAveve=string(squBNve)+'-Sequential-block';
 else
    squDAveve='no Sequential block';
 end

 if IPcBNve>=1
    ipcDAve=string(IPcBNve)+'-IPcore-block';
 else
    ipcDAve='no IPcore block';
 end

 ReUsVe='--'+ascii(32)+'This file has: '+comDAve+','+ascii(32)+squDAveve+','+ascii(32)+ipcDAve+'.';

 endfunction
