//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Embin Map -->vhdl===================\\


function r=wire_mapEI(embindata,number,IN_symbol)



 for j=1:number                                  //embin number
       
     S_tmp='NXU_s'+string(embindata(j)(3));      //signal define      
     B_from='NXUin_'+string(j)+ascii(95)+string(IN_symbol(j));                  //define the input map relationship
     embin_from(j)='assign '+S_tmp+' = '+B_from+ascii(59);  //input ports map  
        
 end    

   
 r=embin_from;                                //get all the map data

