//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Embout Map -->vhdl==================\\

function [s,r]=wire_mapEO(emboutdata,number,OUT_symbol)  



  for j=1:number          //embout number
                               
    S_tmp='NXU_s'+string(emboutdata(j)(2));         //signal define         
    B_from='NXUout_'+string(j)+ascii(95)+string(OUT_symbol(j));                //define the output map relationship

    S_D_embout='wire'+ascii(32)+S_tmp+ascii(59); //signal
    embin_from(j)='assign '+B_from+' = '+S_tmp+ascii(59); //output ports map 
       
  end 



  s=S_D_embout;      //get all the signal data
  r=embin_from;      //get all the map data

