
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity xianfulbnxu is 
  port(in_1: in std_logic;
       in_2: in std_logic;
       in_3: in std_logic;
 	   in_4: in std_logic;
       in_5: in std_logic;
       in_6: in std_logic;
       in_7: in std_logic;
 	   in_8: in std_logic;
       in_9: in std_logic;
       in_10: in std_logic;
       in_11: in std_logic;
 	   in_12: in std_logic;
       in_13: in std_logic;
       in_14: in std_logic;
       in_15: in std_logic;
 	   in_16: in std_logic;
       in_17: in std_logic;
       in_18: in std_logic;
       in_19: in std_logic;
       in_20: in std_logic;
 	   in_21: in std_logic;
       in_22: in std_logic;
 	   in_23: in std_logic;
       in_24: in std_logic;
         --out1 data high
       out_1 : out std_logic;          
       out_2 : out std_logic;
       out_3 : out std_logic;
       out_4 : out std_logic;
 
       out_5 : out std_logic;    
       out_6 : out std_logic;
       out_7 : out std_logic;
       out_8 : out std_logic    
      );
end xianfulbnxu;

architecture one of xianfulbnxu is

  component xianfulb 
    port(a,b,c: in std_logic_vector(7 downto 0);
         y: out std_logic_vector(7 downto 0));
  end component;
 
  signal nxu_in1,nxu_in2,nxu_in3 :  std_logic_vector(7 downto 0);  
  signal nxu_out1 :  std_logic_vector(7 downto 0); 
 
 begin

   nxu_in1 <= in_1&in_2&in_3&in_4&in_5&in_6&in_7&in_8;
   nxu_in2 <= in_9&in_10&in_11&in_12&in_13&in_14&in_15&in_16;
   nxu_in3 <= in_17&in_18&in_19&in_20&in_21&in_22&in_23&in_24;
 
   xianf: xianfulb port map(a=>nxu_in1,b=>nxu_in2,c=>nxu_in3,
                            y=>nxu_out1);
 
   out_1 <= nxu_out1(7);
   out_2 <= nxu_out1(6); 
   out_3 <= nxu_out1(5);
   out_4 <= nxu_out1(4);
 
   out_5 <= nxu_out1(3);
   out_6 <= nxu_out1(2); 
   out_7 <= nxu_out1(1);
   out_8 <= nxu_out1(0);
 
end one;
 
--******************************************************
 --Copyright NXU AGL (2004-2007)
 
 --Powered by scicos-hdl 0.4 ZhangDong&KangCai 2007 NXU
 
 --http://scicoshdl.sourceforge.net
 
--******************************************************
