//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================I/O topfile -->vhdl=================\\


function [NXU_inport,NXU_outport]=Top_port(inport,outport,embin_data_top,embout_data_top);

  in_num=inport;
  out_num=outport;

  in_for='NXUin'+ascii(95);                                   // get the IN ports of VHDL
  in_type=ascii(58)+ascii(32)+'in std_logic'+ascii(59);       // IN port type

  for i=1:in_num
    in_name(i)=in_for+string(embin_data_top(i)(1))+ascii(95)+string(embin_data_top(i)(4));                   // port name:in_1,in_2....
    in_data(i)=in_name(i)+in_type;                         // in_(i): in std_logic;
  end
 // message(in_data)
  out_for='NXUout'+ascii(95);                                         //get the OUT ports of VHDL
  out_type1=ascii(58)+ascii(32)+'out std_logic'+ascii(59);            //OUT port type
  out_type2=ascii(58)+ascii(32)+'out std_logic'+ascii(41)+ascii(59);  //OUT port type

  for i=1:out_num

    tmp_out(i)=i;
    out_name(i)=out_for+string(embout_data_top(i)(1))+ascii(95)+string(embout_data_top(i)(4));              // port name:out_1,out_2...
  
    if i<out_num      
       out_data(i)=out_name(i)+out_type1;              // out_(i): out std_logic;
    else
       out_data(i)=out_name(i)+out_type2; 
    end  
  
  end
  


 NXU_inport=in_data;                                        // VHDL inport

 NXU_outport=out_data;                                      // VHDL outport

 //r=NXU_inport;
 //r=[NXU_inport;NXU_outport];
