//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Component LMP -->vhdl===============\\

function   r=Vhdl_mapB(final_data,Num)         
 
memN=1;
LMP_data='';


for n=1:Num

  LMP_data(memN)='component'+ascii(32)+final_data(n)(3);  
  memN=memN+1; 
  LMP_data(memN)='port(';   
  memN=memN+1;
  
  nxu_in_for='in'+ascii(95);                                   // get the IN ports of VHDL
  nxu_in_type=ascii(58)+ascii(32)+'in std_logic'+ascii(59);    // IN port type
  
  nxu_in_name='';
  for i=1:final_data(n)(4)

     nxu_in_name(i)=nxu_in_for+string(i);                 // port name:in_1,in_2....

  end

  nxu_in_tmp=strcat(nxu_in_name,',');
  LMP_data(memN)=nxu_in_tmp+nxu_in_type;                  // in_(i): in std_logic;
  memN=memN+1;



  nxu_out_for='out'+ascii(95);                         // get the OUT ports of VHDL
  nxu_out_type2=ascii(58)+ascii(32)+'out std_logic'+ascii(41)+ascii(59);  //OUT port type

  nxu_out_name='';
  for i=1:final_data(n)(5)

      nxu_out_name(i)=nxu_out_for+string(i);               // port name:out_1,out_2...

  end

  nxu_out_tmp=strcat(nxu_out_name,',');
  LMP_data(memN)=nxu_out_tmp+nxu_out_type2;
  memN=memN+1;
  
  LMP_data(memN)='end component;'
  memN=memN+1;
 
  
end
  r=LMP_data;
 // r=list(['LMP_name','LMP_port','nxu_in_data','nxu_out_data','LMP_endcom']);

