//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//===============doc    -->verilog==============\\


function DOCrv=blockDocVhdl(docpath,docfileName,docDATA,docNUM,fileInfoKczd)  //doc

  blockNa='';
  finalyGD='';
  num=1;
  len=0;
  spT='';

  fileP='SCI/macros/scicos-hdl/Block_descrip/';
  for i=1:docNUM

     blockNa=fileP+docDATA(i)(2)+'_'+string(docDATA(i)(9))+'.txt';

     B_content=mgetl(blockNa);  //读取文件

     len=size(B_content);
     len=len(1);
      
     B_content(1)='*'+ascii(32)+string(i)+'.'+B_content(1);

     for k=1:len
        if k==1
           finalyGD(num)=B_content(k);  
        else
           finalyGD(num)=ascii(32)+ascii(32)+ascii(32)+B_content(k); 
        end                              
        num=num+1;
     end

     num=num+1;     
  end

  docName='*** file name : '+docfileName+'.cos';
  docHead='';

  for n=1:8
      docHead=docHead+ascii(32);
  end

  docHead=docHead+docName;
  docbodyv='';
  docbodyv='-- The following is the block list:';
  authers=mgetl('SCI/macros/scicos-hdl/vhdl/Copyrightvhdl.txt');

  spT=[docHead;ascii(32);fileInfoKczd;ascii(32);docbodyv;ascii(32);finalyGD;ascii(32);authers];

  //write(docpath+"readme"+'.txt',spT)
  
  mputl(spT,docpath+"readme"+'.txt')


 DOCrv='doc ok !!'

endfunction
