//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Block data -->vhdl=====================\\


function r=block_vhdl(data)

  tmpD=list();
  ipname='';

  order=data(1);  //序号------order
  //message(string(order))

  old_name=data(2);   //旧名?------元件界面函数名称
  //message(old_name)
  new_name=data(3);   //新名?------name

  in_N=data(4);   //输入??--inport

  out_N=data(5);  //输出??--outport
   
  rparD=data(6);
  //message(rparD(6))

  pin=data(7);    //输入连线--inlink

  pout=data(8);   //输出连线--outlink
  
  bipar=data(9);

    //  if rparD(1) ~= 2
    //     tmpD=list(order,old_name,new_name,in_N,out_N,rparD,pin,pout,bipar)  
    //  else
    //    ipname=rparD(2)(1);
    //    tmpD=list(order,old_name,ipname,in_N,out_N,rparD,pin,pout,bipar)
    //  end


  if rparD(1) ~= 2  // conbinational or sequential block
     tmpD=list(order,old_name,new_name,in_N,out_N,rparD,pin,pout,bipar)  
  else
     ipname=rparD(2); //ip core block
     tmpD=list(order,old_name,ipname,in_N,out_N,rparD,pin,pout,bipar)
  end
  //** log 2008 03 11 kc
  //** changer the name fo a block
  //Rr=list(in_N,out_N,pin,pout);

  r=tmpD;
endfunction 
