//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//===============file    -->hdl==============\\


function ReUsVh=forUsersVh(infoD,infoNum,filePp)  //doc
   
 fileI=list();              //every block's VHDL data parameter

 comBN=0;
 comDA='';
 squBN=0;
 squDA='';
 IPcBN=0;
 ipcDA='';

 for i=1:infoNum

    fileI(i)=infoD(i)(6)   //data-->every block VHDL's parameters
                          //come from truthtable_IDC
 end

 for k=1:infoNum

    if fileI(k)(1)==1
       comBN=comBN+1;  //record the comBlocks number
    elseif fileI(k)(1)==3
       squBN=squBN+1;
    else
       IPcBN=IPcBN+1;
    end
 end

 if comBN>=1
    comDA=string(comBN)+'-Combinational-block';
 else
    comDA='no Combinational block';
 end

 if squBN>=1
    squDA=string(squBN)+'-Sequential-block';
 else
    squDA='no Sequential block';
 end

 if IPcBN>=1
    ipcDA=string(IPcBN)+'-IPcore-block';
 else
    ipcDA='no IPcore block';
 end

 ReUsVh='--'+ascii(32)+'This file has: '+comDA+','+ascii(32)+squDA+','+ascii(32)+ipcDA+'.';

 endfunction
