//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================I/O topfile -->vhdl test=================\\


function [test_inport,test_outport,rezult]=testIO_vhdl(inport,outport,embin_data,embout_data);

  in_num=inport;
  out_num=outport;

  in_for='Tb_NXUin'+ascii(95);                                   // get the IN ports of VHDL
  in_type=ascii(58)+ascii(32)+'in std_logic'+ascii(59);            // IN port type

  testikc='';
  testiF='';

  for i=1:in_num
    in_name(i)=in_for+string(embin_data(i)(1));                   // port name:in_1,in_2....
    in_data(i)=in_name(i)+in_type;                         // in_(i): in std_logic;
  //  testikc(i)='NXUin_'+string(i)+' => '+'Tb_NXUin'+string(i);
  end
  testiF=strcat(testikc,',');
  
  testokc='';
  testoF='';

  out_for='Tb_NXUout'+ascii(95);                                         //get the OUT ports of VHDL
  out_type1=ascii(58)+ascii(32)+'out std_logic'+ascii(59);                 //OUT port type
  out_type2=ascii(58)+ascii(32)+'out std_logic'+ascii(41)+ascii(59);       //OUT port type

  for i=1:out_num

    out_name(i)=out_for+string(embout_data(i)(1));            // port name:out_1,out_2...
  
    if i<out_num      
       out_data(i)=out_name(i)+out_type1;              // out_(i): out std_logic;
    else
       out_data(i)=out_name(i)+out_type2; 
    end  
//    testokc(i)='NXUout_'+string(i)+' => '+'Tb_NXUout'+string(i); 
  end
  testoF=strcat(testokc,',');


 test_inport=in_data;                                        // VHDL inport

 test_outport=out_data;                                      // VHDL outport

 //rezult='testmap: '+name+ascii(32)+'port map('+ testiF+','+testoF+')'+ascii(59)

 //r=NXU_inport;
 //r=[NXU_inport;NXU_outport];

