
 function testb_data=testb(fileName,filePath,inData,outData,tb_blklst,cmat,inport,embin_data,outport,embout_data) 
 //testbench --> vhdl 2007.11.08  kc RNIRA
// message("== ==")
  getf(SCI+"/macros/scicos-hdl/vhdl/check_p_define.sci");
  getf(SCI+"/macros/scicos-hdl/vhdl/pattern_array_define.sci");
  getf(SCI+"/macros/scicos-hdl/vhdl/tb_component_define.sci");
  getf(SCI+"/macros/scicos-hdl/vhdl/tb_signl_define.sci");
  getf(SCI+"/macros/scicos-hdl/vhdl/tb_type_define.sci");

  TbName=fileName+'_tb';  //test bench name
  
     global G_G_debug ; // 0 NO other =debug
     if G_G_debug>0 then
                 message("testb.sci11");
                 pause;
     end
         
         
  //entity define
  Tb_entity(1)="library IEEE;";    
  
  Tb_entity(2)="use ieee.std_logic_1164.ALL;";
  
  Tb_entity(3)="--  A testbench has no ports.";     
  
  Tb_entity(4)="entity"+ascii(32)+TbName+ascii(32)+"is";
  
  Tb_entity(5)="end"+ascii(32)+TbName+ascii(59); 
  
  Tb_entity(6)=ascii(32);
  
  //architecture define
  Tb_arch(1)="architecture behav of"+ascii(32)+TbName+ascii(32)+"is"; 
  
  Tb_arch(2)="--  Declaration of the component that will be instantiated.";
  
  //block component
  Tb_lmp(1)="component"+ascii(32)+fileName;  
  
  Tb_lmp(2)="port(";
  
  //TBcomponentIn,TBcomponentOut will be here
  
  tb_lmpE="end component"+ascii(59);
  
  //entity : bound with
  bound_w(1)="--  Specifies which entity is bound with the component.";
  
  bound_w(2)="for "+fileName+"_0: "+fileName+ascii(32)+"use entity work."+fileName+ascii(59);
 
  //signal define
  signal_def=tb_signl_define(inport,outport,embout_data);

  //begin
  begin_d="begin";
  
  //Component instantiation.
  component_h="--  Component instantiation.";
  component_def=tb_component_define(inport,embin_data,outport,embout_data,fileName,cmat,tb_blklst);

  //process
  process_h(1)=" --  This process does the real job.";
  process_h(2)="process";
  process_h(3)="type pattern_type is record";
  process_h(4)="--  The inputsThe expected outputs.";
  [type_def_in,type_def_out]=tb_type_define(inport,outport);
  //** type_def_in
  //** type_def_out
  process_e(1)="end record"+ascii(59);
  process_e(2)="--  The patterns to apply.";
  //patterns to apply
  
  pattern_h(1)="type pattern_array is array (natural range <>) of pattern_type"+ascii(59);
  pattern_h(2)="constant patterns : pattern_array :=";
  
  pattern_array_def=pattern_array_define(tb_blklst);
  
  //** begin_d="begin"
  
  //Check each pattern
  check_h(1)="--  Check each pattern.";
  check_h(2)="for i in patterns"+ascii(39)+"range loop";
  check_h(3)="--  Set the inputs.";
  
  check_p_def=check_p_define(inport);
  
  //message(pattern_h)
  //message('+')
  //message(pattern_array_def)  //er
  //message('++')
  //message(check_h)
  //end of testbench
  end_behav(1)="--  Wait for the results.";
  end_behav(2)="wait for 1 ns;";
  end_behav(3)="end loop;";
  end_behav(4)="wait;";
  end_behav(5)="end process;";
  end_behav(6)="end behav;";
   
  test_top='';
  test_top=[Tb_entity;Tb_arch;Tb_lmp;inData;outData;tb_lmpE;bound_w;signal_def;begin_d;component_h;component_def];
  test_top=[test_top;process_h;type_def_in;process_e;pattern_h;pattern_array_def;begin_d;check_h;check_p_def;end_behav];
  //----------------------------------------------------------------------------------------

  TbInwave='tbInwave'+'.test';
  Inwave='--write the input wave data as the input data to test the * '+TbName+'.vhd'+' *';

  TboutWave='tboutWave'+'.test';
  OutWave='--save the test data of * '+TbName+'.vhd'+' *';
  
  VHDLTBkc='';
  VHDLTBkc=spitline(test_top);

  mdelete(filePath+TbName+'.vhd');
  mputl(VHDLTBkc,filePath+TbName+'.vhd');
  //mputl(VHDLTBkc,SCI+TbName+'.vhd');  //for test
  
//
//  //write(TBfilePath+TbInwave,Inwave)
//  mdelete(filePath+TbName+'.vhd');
//  mputl(Inwave,filePath+TbInwave)

  //write(TBfilePath+TboutWave,OutWave)
//  mdelete(filePath+TbName+'.vhd');
//  mputl(OutWave,filePath+TboutWave);

  mclose('all');

  testb_data='-- test bench ok'
    
       global G_G_debug ; // 0 NO other =debug
       if G_G_debug>0 then
             message("testb.sci");
       end
         
         
endfunction

