//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//===============Block Map -->vhdl=====================\\


function  [s,r]=vhdl_BlockMap(B_data,number,link_data)

  //(listNum,block_gui,new_name,nin_num,out_num,block_rpar,block_pin,block_pout)

  newB_name='';
  sinN='';
  sinII='';
  outportF='';
  inportF='';
  blockNall='';
  blocksigF='';
  
  link_num=size(link_data,1);


  for i=1:number 

    if B_data(i)(6)(1)==2
       newB_name=B_data(i)(6)(2);  //the name of block IP ????????5-12
      // message(newB_name)
    else
       newB_name=B_data(i)(3);  //the name of block
    end
// message(newB_name)
    //-----------------------------------------------------------
      
      for t=1:B_data(i)(4)   // input-->signal define
        
        
         for zk=1:link_num
             if (cmat(zk,3)==B_data(i)(1)) & (cmat(zk,4)==t) then
                sinN='NXU_s'+string(zk);
                niniM(t)='in_'+string(cmat(zk,4))+ascii(32)+'=>'+ascii(32)+sinN; 
                sinII(t)= sinN ;//'NXU_s'+string(B_data(i)(7)(t,1));
             end   
         end
 
//        sinN='NXU_s'+string(B_data(i)(7)(t,1));
//          
//          
//          
//          niniM(t)='in_'+string(t)+ascii(32)+'=>'+ascii(32)+sinN;      
//          sinII(t)= sinN ;//'NXU_s'+string(B_data(i)(7)(t,1));
      end
      inportF=strcat(niniM,',');  //map indata
      sigtemp=strcat(sinII,',');  
      signalF='signal'+ascii(32)+sigtemp+ascii(58)+ascii(32)+'std_logic'+ascii(59);
    
      sinN='';
    
    //----------------------------------------------------------
         
    for h=1:B_data(i)(5) 

         for zk=1:link_num
             if (cmat(zk,1)==B_data(i)(1)) & (cmat(zk,2)==h) then
                sinN='NXU_s'+string(zk);
                oinOM(h)='out_'+string(cmat(zk,2))+ascii(32)+'=>'+ascii(32)+sinN; 
             end   
         end





//       sinN='NXU_s'+string(B_data(i)(8)(h,1));
//       oinOM(h)='out_'+string(h)+ascii(32)+'=>'+ascii(32)+sinN;        //define the output map relationship
      
    end
    outportF=strcat(oinOM,',');  //map outdata

    blockNall(i)='NXUmap'+string(i)+ascii(58)+ascii(32)+newB_name+ascii(32)+'port map('+inportF+','+outportF+')'+ascii(59);
    blocksigF(i)=signalF;
    
    sinN='';
    signalF='';
    outportF='';
    inportF='';
    oinOM='';
    niniM='';
    sinII='';
    signalF='';
    newB_name='';
  end


  s=blocksigF

  r=blockNall;


endfunction












