 
library IEEE;
use ieee.std_logic_1164.ALL;
entity norgate4_4_1 is
port(
in_1: in std_logic;
in_2: in std_logic;
in_3: in std_logic;
in_4: in std_logic;
out_1: out std_logic);
end norgate4_4_1;
architecture NXU_beh of norgate4_4_1 is
begin
p1: process(in_1,in_2,in_3,in_4)
variable indata: std_logic_vector(3 downto 0);
begin
indata := in_1&in_2&in_3&in_4;
case indata is
when "0000" =>
out_1 <= '1';
when "1000" =>
out_1 <= '0';
when "0100" =>
out_1 <= '0';
when "1100" =>
out_1 <= '0';
when "0010" =>
out_1 <= '0';
when "1010" =>
out_1 <= '0';
when "0110" =>
out_1 <= '0';
when "1110" =>
out_1 <= '0';
when "0001" =>
out_1 <= '0';
when "1001" =>
out_1 <= '0';
when "0101" =>
out_1 <= '0';
when "1101" =>
out_1 <= '0';
when "0011" =>
out_1 <= '0';
when "1011" =>
out_1 <= '0';
when "0111" =>
out_1 <= '0';
when "1111" =>
out_1 <= '0';
when others=>
out_1 <= '0';
end case;
end process p1;
end NXU_beh;

 --******************************************************
  --VHDL compiler

  --ZhangDong&KangCai (2004-2008)
 
  --http://scicoshdl.sourceforge.net

 --******************************************************
