module  adder(in_1,in_2,in_3,out_1,out_2);
 input in_1,in_2,in_3;
 output out_1,out_2;

 reg out_1,out_2;

 
always@(in_1 or in_2 or in_3)
   begin
     out_1 = in_1 ^ in_2 ^ in_3;
     out_2 = (in_1 & in_2) | (in_1 & in_3) | (in_2 & in_3);
	 end
 endmodule
  
//******************************************************
  //ZhangDong&KangCai (2004-2008)
 
  //http://scicoshdl.sourceforge.net
 
//******************************************************
