module  half_adder(in_1,in_2,out_1,out_2);
 input in_1,in_2;
 output out_1,out_2;

 reg out_1,out_2;
 reg c,d;
 
always@(in_1 or in_2)
   begin
     c=in_1 | in_2;
     d=~(in_1 & in_2);
     out_2= ~ d;
     out_1=c & d;
	 end
 endmodule
  
//******************************************************
  //ZhangDong&KangCai (2004-2008)
 
  //http://scicoshdl.sourceforge.net
 
//******************************************************
