function [x,y,typ] = hdlzk_testbench_interf(job,arg1,arg2)
//zd&kc scicos-hdl 0.5 2007
x=[];y=[];typ=[];

select job
  
  case 'plot' then  
      standard_draw(arg1)
      
  case 'getinputs' then     //    message('getinputs')
      [x,y,typ]=standard_inputs(arg1)  
      
     // x=[];y=[];typ=[];
  case 'getoutputs' then    //  message('getoutputs')
      [x,y,typ]=standard_outputs(arg1)
    
  case 'getorigin' then     //message('getorigin')
      [x,y]=standard_origin(arg1)
      
  case 'set' then
    
      x = arg1;
      graphics  = arg1.graphics 
      exprs1    = graphics.exprs
      model     = arg1.model
      
      while %t do 
                     
         [ok,ec]=getvalue('Set parameter', ['Port Number'],list('vec',-1),exprs1)

         if ~ok then
            break ; //** exit point 
         end
       
         out=-ones(ec,1);
 
         
         [model, graphics, ok] = check_io(model, graphics,[], out, [1], []);   // verify that the block parameters are OK 
              
         if ok then   
          
           lables=[];
           parameters_init=[];
           str_list_temp=[]; 
           function_bvalue=[];
     
           for i=1:ec
              lables=[ascii(34)+"In_"+string(i)+ "="+ascii(34),lables];   

              if lstsize(model.opar)==ec then
                parameters_init=[ascii(34)+model.opar(i)+ascii(34);parameters_init];
              else
                parameters_init=[ascii(34)+'0'+ascii(34);parameters_init];
              end
    
              str_list_temp  =[ascii(34)+ "str"+ ascii(34) + ",-1",str_list_temp];
              function_bvalue=["In_"+string(i),function_bvalue];
          end  

          lables         =strcat(lables,';') ;  
          parameters_init=strcat(parameters_init,';');
          str_list_temp  =strcat(str_list_temp,',');
          function_bvalue=strcat(function_bvalue,',');

          lables         ='['+lables+']';
          parameters_init='['+parameters_init+']';
          str_list_temp  ="list("+str_list_temp+')';
          function_bvalue='[ok,'+function_bvalue+']';

          mid_data="=getvalue("+ascii(34)+"set truth table for each port"+ascii(34);
 
          execstr(function_bvalue+mid_data+","+lables+","+str_list_temp+","+parameters_init +")");
          
          opar_data =list();

          for k=1:ec
             execstr( "opar_data ("+ string(k) +")=" +  "In_"+string(k))   ;                  
          end  

         //graphics.sz(1)=12 * ec+6 ;  
         if ec>3
         
             graphics.sz(2)=7 * ec+6 ; 
         end         
         
          graphics.exprs =sci2exp( ec) ;  
          model.opar=opar_data;
          x.graphics     = graphics;
          x.model        = model; 
             
          break ; //** exit point 
          
          
         end 
   
   
      end //** of while input loop 
 
 
 
 
 
 
      case 'define' then
        ec=1
        model = scicos_model();
        model.sim=list('hdlzk_testbench_sim',5) ; //** computational function type 5 (Scilab)
        model.in  = [] ;                 //** default 2 inputs
        model.out = -1 ;         //** default one output      
       
        model.evtin=1;                   //event input
        model.dstate=0; 
        
        model.blocktype = 'd' ;          //** continous block type 
        model.dep_ut = [%t %f] ;  
        model.opar =list();              //TYPE,TB,IN,OUT,STATE,GUI_NAME         
        exprs =sci2exp( ec);
                                  
        gr_i=['xstringb(orig(1),orig(2),[''TEST'';''Bench''],sz(1),sz(2),''fill'')']
 
        x = standard_define([2 2], model, exprs, gr_i)
        

end //** of select 

endfunction
