
`include "adder8.v"
  
module adder8nxu(in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,in_10,in_11,
              in_12,in_13,in_14,in_15,in_16,in_17,out_1,out_2,out_3,out_4,
                 out_5,out_6,out_7,out_8,out_9);
  input in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,in_10,in_11,in_12,
        in_13,in_14,in_15,in_16,in_17;
  output out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8,out_9;
  wire [7:0] nxu_in1,nxu_in2; 
  wire [7:0] nxu_out1; 

 assign nxu_in1 = {in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8};
 assign nxu_in2 = {in_9,in_10,in_11,in_12,in_13,in_14,in_15,in_16};

 adder8 mapp(.a(nxu_in1),.b(nxu_in2),.cin(in_17),.sum(nxu_out1),.cout(out_9));

 assign {out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8} = nxu_out1;

 endmodule


//******************************************************
 //Copyright NXU AGL (2004-2007)
 
 //Powered by scicos-hdl 0.4 ZhangDong&KangCai 2007 NXU
 
 //http://scicoshdl.sourceforge.net
 
//******************************************************
