
 `include "decoder74138.v"
  module decoder74138nxu(in_1,in_2,in_3,in_4,in_5,in_6,out_1,
                         out_2,out_3,out_4,out_5,out_6,out_7,out_8);
  input in_1,in_2,in_3,in_4,in_5,in_6;
  output out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8;
  wire [2:0] nxu_in1; 
  wire [7:0] nxu_out1; 

 assign nxu_in1 = {in_4,in_5,in_6};

 decoder74138 decodermap(.g1(in_1),.g2(in_2),.g3(in_3),
                         .datain(nxu_in1),.y(nxu_out1));

   assign  {out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8}= nxu_out1;

 endmodule

//******************************************************
 //Copyright NXU AGL (2004-2007)
 
 //Powered by scicos-hdl 0.4 ZhangDong&KangCai 2007 NXU
 
 //http://scicoshdl.sourceforge.net
 
//******************************************************
