
  `include "demuxBUS_3.v"

  module demuxBUS_3nxu(in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,
              in_10,in_11,in_12,in_13,in_14,in_15,in_16,in_17,in_18,
              in_19,in_20,in_21,in_22,in_23,in_24,in_25,in_26,out_1,
              out_2,out_3,out_4,out_5,out_6,out_7,out_8);

  input in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,
        in_9,in_10,in_11,in_12,in_13;
  input in_14,in_15,in_16,in_17,in_18,in_19,in_20,
        in_21,in_22,in_23,in_24,in_25,in_26;

  output out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8;

  wire [7:0] nxu_in1,nxu_in2,nxu_in3; 
  wire [7:0] nxu_out1; 

 assign nxu_in1 = {in_3,in_4,in_5,in_6,in_7,in_8,in_9,in_10};
 assign nxu_in2 = {in_11,in_12,in_13,in_14,in_15,in_16,in_17,in_18};
 assign nxu_in3 = {in_19,in_20,in_21,in_22,in_23,in_24,in_25,in_26};

demuxBUS_3 mappp(.s1(in_1),.s2(in_2),.data1(nxu_in1),.data2(nxu_in2),
                 .data3(nxu_in3),.y1(nxu_out1));

assign {out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8} = nxu_out1;

endmodule

//******************************************************
 //Copyright NXU AGL (2004-2007)
 
 //Powered by scicos-hdl 0.4 ZhangDong&KangCai 2007 NXU
 
 //http://scicoshdl.sourceforge.net
 
//******************************************************
