
`include "shiftR75.v"
  
module shiftR75nxu(in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9,out_1,
                   out_2,out_3,out_4,out_5,out_6,out_7,out_8);

  input in_1,in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9;
  output out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8;

  wire [7:0] nxu_in1; 
  wire [7:0] nxu_out1; 

 assign nxu_in1 = {in_2,in_3,in_4,in_5,in_6,in_7,in_8,in_9};

 shiftR75 mapp(.clk(in_1),.a(nxu_in1),.y(nxu_out1));

 assign {out_1,out_2,out_3,out_4,out_5,out_6,out_7,out_8} = nxu_out1;

 endmodule


//******************************************************
 //Copyright NXU AGL (2004-2007)
 
 //Powered by scicos-hdl 0.4 ZhangDong&KangCai 2007 NXU
 
 //http://scicoshdl.sourceforge.net
 
//******************************************************
