//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//===============test verilog -->verilog==============\\


function TBrezult=testbench_verilog(TBinport,TBoutport,TBfileName,TBfilePath,TB_IN_symbol,TB_OUT_symbol)  //test bench

//----------------------------------------test bench-------------------------------------

  timeD=ascii(96)+'timescale'+ascii(32)+'1ns'+ascii(47)+'1ns'
  
  //co='// --Copyright NXU AGL'
  //cosp=ascii(32);
  //ok='// --Powered by scicos-hdl 0.3 ** ZhangDong&KangCai 2006 NXU'; //symbol of victor
  cosp=ascii(32);
  ok=mgetl('SCI/macros/scicos-hdl/verilog/Copyrightverilog.txt'); //symbol of victory
  
  testN=TBfileName+'_tb';
  
  endpp='endmodule';

  testIN=ascii(96)+'include'+ascii(32)+ascii(34)+TBfileName+'.v'+ascii(34);
  
  TB_IN_symbol_temp='';
  TB_OUT_symbol_temp='';
  
  TB_IN_symbol_temp=TB_IN_symbol;
  TB_OUT_symbol_temp=TB_OUT_symbol

  [test_inM,test_outM,test_inde,test_outde,testmap]=testIO_verilog(TBinport,TBoutport,fileName,TB_IN_symbol_temp,TB_OUT_symbol_temp);  //for the test file
  
  test_h='module'+ascii(32)+testN+ascii(40)+test_inM+','+test_outM+ascii(41)+ascii(59);
  
  testDf='';
  testDf=[cosp;testIN;;timeD;test_h;test_inde;test_outde;testmap;endpp;cosp;ok]
  
  VerilogTBKC='';
  VerilogTBKC=spitline(testDf);
  
  //write(TBfilePath+testN+'.v',VerilogTBKC);
  mdelete(TBfilePath+testN+'.v');
  mputl(VerilogTBKC,TBfilePath+testN+'.v');

  
  testInwave='testInwave'+'.test';
  Inwave='//write the input wave data as the input data to test the * '+TBfileName+'.v'+' *';

  testoutWave='testoutWave'+'.test';
  OutWave='//save the test data of * '+TBfileName+'.v'+' *';

  //write(TBfilePath+testInwave,Inwave)
  mdelete(TBfilePath+testInwave);
  mputl(Inwave,TBfilePath+testInwave);
  
  //write(TBfilePath+testoutWave,OutWave)
  mdelete(TBfilePath+testoutWave);
  mputl(OutWave,TBfilePath+testoutWave);
 
  mclose('all');
  TBrezult='-test bench ok'; //symbol of victory










endfunction


