//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================I/O topfile -->vhdl test=================\\


function [tb_sigINbk,tb_sigOTbk,rezult,InportMapD,OtportMapD]=tb_Vhdl_signal_Define(inport,outport,name,IN_symbol,OUT_symbol,embin_data,embout_data);

  in_num=inport;    //INput ports number
  out_num=outport;  //output ports number

  in_for='TbzkIn'+ascii(95);                                       // get the signal IN ports of VHDL
  in_type=ascii(58)+ascii(32)+'std_logic'+ascii(59);            // IN port type

// signal map input port ------------------------------------------------------------------------

  testikc=[];
  testiF=[];
  tbinpSgDATA='';
  portMapDaIn=[]

  for i=1:in_num
    in_name(i)=in_for+string(embin_data(i)(1));                     // port name
    portMapDaIn(i)=in_name(i)+' <= '+'Tb_NXUin_'+string(embin_data(i)(1))+ascii(59);
    testikc(i)='NXUin_'+string(embin_data(i)(1))+ascii(95)+string(IN_symbol(i))+' => '+in_name(i);
  end
  testiF=strcat(testikc,',');      //map data  
  tbinpSgDATA="signal"+ascii(32)+strcat(in_name,',')+in_type; //signal xxxxxxxx : std_logic;
  InportMapD=portMapDaIn;  //xxx <= tb in
  
// signal map output port ------------------------------------------------------------------------  
    
  testokc=[];
  testoF=[];
  tbotpSgDATA='';
  portMapDaOt=[]

  out_for='TbzkUt'+ascii(95);                                         //get the OUT ports of VHDL

  for i=1:out_num
    out_name(i)=out_for+string(embout_data(i)(1));            // port name:out_1,out_2...
    portMapDaOt(i)='Tb_NXUout_'+string(embout_data(i)(1))+' <= '+out_for+string(embout_data(i)(1))+ascii(59); 
    testokc(i)='NXUout_'+string(embout_data(i)(1))+ascii(95)+string(OUT_symbol(i))+' => '+out_name(i); 
  end
  
  testoF=strcat(testokc,',');
  tbotpSgDATA="signal"+ascii(32)+strcat(out_name,',')+in_type; //signal xxxxxxxx : in std_logic;
  OtportMapD=portMapDaOt;   //out <= tb out
  
  //message('tbotpSgDATA='+tbotpSgDATA) 
  //message('testiF='+testoF)
  
 // xxx <= in.. ------------------------------------------------------------------------  
 
 tb_sigINbk=tbinpSgDATA;
 tb_sigOTbk=tbotpSgDATA
 rezult='testmap: '+name+ascii(32)+'port map('+ testiF+','+testoF+')'+ascii(59)

 //r=NXU_inport;
 //r=[NXU_inport;NXU_outport];

