//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Embout Map -->vhdl==================\\

function [s,r]=vhdl_OutMap(emboutdata,number)

  for j=1:number          //embout number
                               
    S_tmp='NXU_s'+string(emboutdata(j)(2));    //signal define
    S_D_embout(j)='signal'+ascii(32)+S_tmp+ascii(58)+ascii(32)+'std_logic'+ascii(59);//signal
         
    B_from='NXUout_'+string(emboutdata(j)(1))+ascii(95)+string(emboutdata(j)(4));                //define the output map relationship
    embin_from(j)=B_from+'<='+S_tmp+ascii(59); //output ports map 
       
  end 

  s=S_D_embout;      //get all the signal data
  r=embin_from;      //get all the map data

