//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================EMB -->START========================\\

function OK=vhdl_start(cos_File_path,vhdl_File_path)    //start Scicos-HDL


  getf(SCI+'/macros/scicos-hdl/vhdl/vhdlCompiler.sci');      //数据读取 总模?

  getf(SCI+'/macros/scicos-hdl/vhdl/vhdlBlock.sci');         //元件数据分?器
     
  getf(SCI+'/macros/scicos-hdl/vhdl/vhdlLink.sci');          //连线数据分?器

  getf(SCI+'/macros/scicos-hdl/vhdl/library.sci');           //联接元件?

  getf(SCI+'/macros/scicos-hdl/vhdl/Vhdl_out.sci');          //输出元件解析噡

  getf(SCI+'/macros/scicos-hdl/vhdl/Vhdl_in.sci');           //输入元件解析噡

  getf(SCI+'/macros/scicos-hdl/vhdl/block_vhdl.sci');        //实体元件解析噡
 
  getf(SCI+'/macros/scicos-hdl/vhdl/Vhdl_filter.sci');       //库元件过滤器

  getf(SCI+'/macros/scicos-hdl/vhdl/Vhdl_B_Admin.sci');      //元件编译管理噡

  getf(SCI+'/macros/scicos-hdl/vhdl/Vhdl_convert_Com.sci');  //组合逻辑 元件编译噡

  getf(SCI+'/macros/scicos-hdl/vhdl/Vhdl_convert_Seq.sci');  //时序逻辑 元件编译噡

  getf(SCI+'/macros/scicos-hdl/vhdl/Vhdl_convert_IPc.sci');  //IPcore 元件编译噡
 
  getf(SCI+'/macros/scicos-hdl/vhdl/splitintoline.sci');  //IPcore 元件编译
  
  getf(SCI+'/macros/scicos-hdl/vhdl/spitline.sci');  //IPcore 元件编译

  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  getf(SCI+'/macros/scicos-hdl/vhdl/Top_port.sci');       //顶层文件 实体?口生成器

  getf(SCI+'/macros/scicos-hdl/vhdl/Vhdl_mapB.sci');      //顶层文件 元件调用衡 

  getf(SCI+'/macros/scicos-hdl/vhdl/vhdl_BlockMap.sci');  //顶层文件 元件映射衡

  getf(SCI+'/macros/scicos-hdl/vhdl/vhdl_InMap.sci');     //顶层文件 输入?口映射表

  getf(SCI+'/macros/scicos-hdl/vhdl/vhdl_OutMap.sci');    //顶层文件 输出?口映射表

  //================================================================================================

  getf(SCI+'/macros/scicos-hdl/vhdl/testbench_vhdl.sci');     //test bench

  getf(SCI+'/macros/scicos-hdl/vhdl/testIO_vhdl.sci');        //test bench
  
   getf(SCI+'/macros/scicos-hdl/vhdl/tb_Vhdl_signal_Define.sci');        //test bench

  //================================================================================================

  getf(SCI+'/macros/scicos-hdl/vhdl/forUsersVh.sci');        //doc 
 
  getf(SCI+'/macros/scicos-hdl/vhdl/blockDocVhdl.sci');        //doc  

  //================================================================================================
  
  getf(SCI+'/macros/scicos-hdl/vhdl/scs_all_supper2block.sci')  //super blocks
  
  getf(SCI+'/macros/scicos-hdl/vhdl/nxu_s2p_one.sci')
  getf(SCI+'/macros/scicos-hdl/vhdl/cos2cosfoo.sci')
  getf(SCI+'/macros/scicos-hdl/vhdl/clearDeleted.sci')
  getf(SCI+'/macros/scicos-hdl/vhdl/updateBlocklink.sci')
  
  getf(SCI+'/macros/scicos-hdl/scicoshdl_format.sci')
  
  getf(SCI+'/macros/scicos-hdl/vhdl/split_line.sci');
////  
  getf(SCI+'/macros/scicos-hdl/vhdl/testb.sci');
  getf(SCI+'/macros/scicos-hdl/vhdl/check_p_define.sci');
  getf(SCI+'/macros/scicos-hdl/vhdl/pattern_array_define.sci');
  getf(SCI+'/macros/scicos-hdl/vhdl/tb_component_define.sci');
  getf(SCI+'/macros/scicos-hdl/vhdl/tb_signl_define.sci');
  getf(SCI+'/macros/scicos-hdl/vhdl/tb_type_define.sci');
//

// hdl_system file load

 getf(SCI+'/macros/scicos-hdl/sys_hdl/sys_hdl_out_link.sci'); //


//--  end
  

  //================================================================================================
  vhdl_File_Fpath=vhdl_File_path+'/'

  kczd_test=vhdlCompiler(cos_File_path,vhdl_File_Fpath)
  
  //cos_File_path :Scicos file path
  //vhdl_File_path:vhdl file saving path for users

  
  //=================================================================================================
  //cosPath="/scilab4/users/test2/test2.cos";  //用户存文件的?*

  //kczd_test=cosCompiler(cosPath)             //开始执?

//===================================================================================================
//message(string(kczd_test))

if string(kczd_test)=='ok' then
  
//===================================================================================================

 p1=' >>  HDL Project Path : '+vhdl_File_path+'.';
 p2=' >>  Note : We save your vhdl in the defaut path.';
 p3=' >>  Scicos-HDL 0.5  Copyright (c) 2004-2008';
 p4=' >>  ZhangDong&KangCai (NXU, LIAMA, INRIA) '
 p6=' >>  Project Compiled 100% '
 
 LPline=''; 
 Lp1=length(p1);
 Lp2=length(p2);
 if Lp2 > Lp1 then
    for i =1:Lp2+Lp2-10
        LPline=LPline+'-';
    end 
 else
    for i =1:Lp1+Lp1-10
        LPline=LPline+'-';
    end 
 end

  global kczd_ghdl_isrun ; 
        
  if  kczd_ghdl_isrun  ==1  then
      KCPP_ZK="ff"
  else
     if length(vhdl_File_path)<4
        vhdl_File_path=vhdl_File_path+' dose not exist!'
        message([' ';p2;LPline;p3;LPline;p4;LPline])
        //message('+')
     else
        message([' ';p6;LPline;p1;LPline;p3;LPline;p4;LPline]) 
        //message('++')
     end
   
  end
   
 OK='!!Scicos-HDL -- OK!!';
 
else
  
 message(["Please put Input\Output block in your file !";"Scicos-HDL Compiler exit !"]); 
 OK='exit';
 return;
 
end  

endfunction
